

; 
;
;                          Formtovn disket
;
; 

NUMVOL   EQU       15                       ; poet poloek voleb parametr
FORMOFFS EQU       9                        ; offset definice jednoho formtu
VOLOFFS  EQU       7                        ; offset definice jedn poloky
MAXSEKT  EQU       36                       ; maximln poet sektor
BUFFSIZE EQU       36*200h                  ; velikost jednoho diskovho bufferu
MAXFAT   EQU       17                       ; maximln poet sektor FAT
BUFFFAT  EQU       17*200h                  ; velikost bufferu pro FAT

COMMENT %                        Vzhled obrazovky:
ͻ
 12.06.1993        FORM verze 2.0    (c) Miroslav Nmeek         12:33:40  
͹
   Operan systm        Zobrazen obsahu        Opakovn pi chyb   1   
   Nvt disku          Zrychlen start         Testovac zpis       0   
   Zachovn dat DISK      Zptn smr             Formtovac znak     F6   
   Jedna strana           Zvukov indikace        ernobl displej        
   Poloek v Root 224      Verifikace              etina     Kamenickch   
ͼ
  
                                                                              
                ͻ          ͻ                  
                    Disk A:                Disk  B:                   
                ͹        ͹                
                  Automatick            Automatick                  
                   1:  1.2M               1: 1.44M                    
                   2:  720K               2:  720K                    
                   3:  360K               3: 2.88M                    
                   4:  320K               4:  360K                    
                                                                      
                                                                      
                ͼ        ͼ                
                                            
                                                                              
  F1=npovda; vlevo/vpravo=volba disku; TAB=zmna okna; ENTER=volba formtu  
%

; -----------------------------------------------------------------------------
;        konstanty
; -----------------------------------------------------------------------------

HI       EQU       256

b0       EQU       1
b1       EQU       2
b2       EQU       4
b3       EQU       8
b4       EQU       10h
b5       EQU       20h
b6       EQU       40h
b7       EQU       80h
b8       EQU       100h
b9       EQU       200h
b10      EQU       400h
b11      EQU       800h
b12      EQU       1000h
b13      EQU       2000h
b14      EQU       4000h
b15      EQU       8000h

; 
;
;                          Start programu
;
; 

Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         org       100h

; ------ pedefinovn zsobnku

Start:   mov       dx,offset MemTxt         ; text - nedostatek pamti
         cmp       sp,offset Konec
         jb        Chyba                    ; nedostatek pamti
         mov       sp,offset Konec

; ------ zmenen velikosti bloku programu

         mov       ah,4ah
         mov       bx,(offset(Konec-Start)+10fh)/16
         int       21h                      ; zmenen bloku programu
         jc        Chyba                    ; chyba

; ------ vytvoen bufferu text

         mov       bx,(offset(TextEnd-TextBeg)+0fh)/16 ; velikost bufferu text
         mov       ah,48h
         int       21h                      ; vytvoen bufferu text
         jc        Chyba                    ; chyba pamti
         mov       ds:[BuffTxt],ax          ; adresa bufferu text

; ------ schova text do bufferu

         mov       es,ax                    ; adresa bufferu
         xor       di,di
         mov       si,offset TextBeg        ; zatek text
         mov       cx,offset(TextEnd-TextBeg)
         cld
         rep       movsb                    ; schova text do bufferu

; ------ vytvoen datovho bloku pro buffery

         mov       bx,4*(BUFFSIZE/16)+17    ; velikost buffer
         mov       ah,48h
         int       21h                      ; vytvoen datovch buffer
         jc        Chyba                    ; chyba - nedostatek pamti

; ------ adresy buffer

         call      InitBuff                 ; adresa bufferu 1
         mov       ds:[BufferW],cx          ; adresa zpisovho bufferu
         call      InitBuff                 ; adresa bufferu 2
         mov       ds:[BufferR],cx          ; adresa techo bufferu
         call      InitBuff                 ; adresa bufferu 3
         mov       ds:[BufferD],cx          ; adresa datovho bufferu
         call      InitBuff                 ; jet ppadn buffer pro FAT
         cmp       word ptr ds:[BufferF],0  ; byl buffer FAT vytvoen ?
         jne       Start1                   ; byl vytvoen OK
         mov       ds:[BufferF],cx          ; adresa bufferu FAT

; ------ stanoven potu a parametr disketovch mechanik

Start1:  call      GetDTyp                  ; stanoven potu a parametr mech.

; ------ chyba - nen dn disketov mechanika

         cmp       byte ptr ds:[NumDisk],0
         jne       Start2                   ; je njak mechanika OK
         mov       dx,offset DiskTxt        ; chyba - nen dn mechanika
Chyba:   mov       ah,9
         int       21h
         int       20h

; ------ instalace obsluh peruen

Start2:  mov       ax,2523h
         mov       dx,offset INT23
         int       21h
         mov       ax,2524h
         mov       dx,offset INT24
         int       21h

; ------ instalace INT 08h

         mov       ax,3508h
         int       21h
         mov       word ptr ds:[Old08],bx
         mov       word ptr ds:[Old08+2],es
         mov       dx,offset Int08
         mov       ax,2508h
         int       21h

; ------ instalace pznaku peruen

         mov       ax,3300h
         int       21h                      ; poskytnut BREAK
         mov       ds:[OldBreak],dl         ; schova pznaku BREAK
         mov       dl,0                     ; BREAK je vypnut
         mov       ax,3301h
         int       21h                      ; zkaz pznaku BREAK

; ------ inicializace videomdu

         call      DetCard                  ; detekce videokarty EGA/VGA
         call      InitFont                 ; inicializace font a videomdu
         call      InitMous                 ; inicializace ovladae myi
         call      InitRnd                  ; inicializace genertoru nhody

; ------ stanoven pozic k zobrazen jednotlivch disk

         mov       bh,ds:[NumDisk]          ; poet disk
         mov       al,18                    ; ka jednoho okna
         mul       bh                       ; ka na vechna okna
         sub       ax,80
         neg       ax                       ; zbytek na mezery
         inc       bh                       ; poet disk + 1
         div       bh                       ; jedna mezera
         mov       bl,al                    ; schova mezery
         inc       ax                       ; trochu korekce
         mov       cx,4
         mov       ds:[PozDiskT],al         ; pozice disku A:
         add       al,18
         add       al,bl
         mov       ds:[PozDiskT+1],al       ; pozice disku B:
         add       al,18
         add       al,bl
         mov       ds:[PozDiskT+2],al       ; pozice disku C:
         add       al,18
         add       al,bl
         mov       ds:[PozDiskT+3],al       ; pozice disku D:
         call      IniDPar                  ; inicializace parametr akt. disku

; ------ zobrazen obrazovky pro volbu formtu

         call      DispRam                  ; zobrazen podkladovho rmu

Start5:  call      DispPod                  ; zobrazen podkladu

; ------ zobrazen vech disk

Start51: call      DispADsk                 ; zobrazen vech disk
         call      DispVol                  ; zobrazen voleb

; ------ ekn na stisk klvesy

Start53: call      KurzOff
         call      MouseGet                 ; vstup z ovladae myi
         cmp       bl,4                     ; stisk pravho tlatka ?
         jne       Start54
         jmp       Start9                   ; stisk pravho tlatka - konec
Start54: cmp       bl,6                     ; druh stisk levho tlatka ?
         je        Strt5402
Start540:cmp       bl,3                     ; stisk levho tlatka ?
         je        Strt5402
Strt5401:jmp       Start55                  ; nen stisk levho tlatka
Strt5402:cmp       dh,9
         ja        Start541
         and       byte ptr ds:[MouseKey],not b0 ; zruen levho tlatka
         xor       byte ptr ds:[MouseTim+1],1 ; neplatn as myi
         jmp       Start8                   ; volba parametr

; ------ volba formtu v oknech

Start541:cmp       dh,11
         jb        Strt5401
         cmp       dh,21
         ja        Strt553
         mov       al,0                     ; ukazatel sla disku
         mov       si,offset PozDiskT       ; tabulka pozic oken disk
Start542:mov       bh,ds:[si]               ; poten pozice okna disku
         cmp       dl,bh
         jb        Start543
         add       bh,17
         cmp       dl,bh
         jb        Start544
Start543:inc       al
         inc       si
         cmp       al,ds:[NumDisk]
         jb        Start542
         jmp       short Start55

Start544:cmp       al,ds:[AktDisk]
         je        Strt5442
         mov       bl,3
Strt5442:mov       ds:[AktDisk],al          ; nov aktivn disk
         mov       bh,ds:[AktForm]
         mov       byte ptr ds:[AktForm],-1 ; aktivn formt neplatn
         call      IniDPar                  ; inicializace parametr akt. disku
         sub       dl,ds:[si]
         je        Strt5445
         cmp       dl,16
         je        Strt5445
         sub       dh,14
         jb        Strt5445
         cmp       dh,ds:[NumForm]
         jae       Strt5445
         mov       ds:[AktForm],dh
         cmp       bh,ds:[AktForm]
         je        Strt5443
Strt5445:mov       bl,3
Strt5443:call      IniDPar
Start545:cmp       bl,6
         mov       bx,0dh
         je        Start56
Strt5444:jmp       Start51

; ------ ovldn my pomoc npovdy

Strt553: cmp       dh,24
         jne       Start55
         cmp       bl,3
         jne       Start55
         cmp       dl,39
         jb        Start55
         mov       bx,0dh                   ; Enter
         cmp       dl,54
         jbe       Start56
         mov       bl,1bh                   ; Esc
         cmp       dl,65
         jbe       Start56
         mov       bx,3b00h                 ; F1
         jmp       short Start56

Start55: call      TestKey
         jnc       Start552
         jmp       Start53                  ; nen znak z klvesnice

Start552:
         call      InpKey

Start56: mov       al,ds:[AktForm]          ; aktivn formt
         mov       ah,ds:[NumForm]          ; poet monch formt
         call      JumpBX                   ; skok na obsluhu podle klvesy

         dw        9,Start66                ; Tab
         dw        0f00h,Start65            ; Shift-Tab
         dw        4d00h,Start64            ; vpravo
         dw        4b00h,Start63            ; vlevo
         dw        4800h,Start62            ; nahoru
         dw        5000h,Start61            ; dol
         dw        4700h,Start611           ; Home
         dw        4f00h,Start621           ; End
         dw        4900h,Start611           ; Page Up
         dw        5100h,Start621           ; Page Down
         dw        4300h,Start8             ; F9
         dw        13,Start7                ; ENTER
         dw        27,Start9                ; ESC

         dw        0,Start53

; ------ kurzor dol

Start61: inc       al
         cmp       al,ah
         jb        Start612
Start611:mov       al,0
Start612:mov       ds:[AktForm],al
Start613:call      IniDPar                  ; inicializace parametr akt. disku
         jmp       Start51

; ------ kurzor nahoru

Start62: dec       al
         jns       Start612
Start621:mov       al,ah
         dec       al
         jmp       short Start612

; ------ kurzor vlevo

Start63: mov       al,ds:[AktDisk]
         or        al,al
         jz        Start632
         dec       al
Start632:mov       ds:[AktDisk],al          ; nov aktivn disk
         mov       byte ptr ds:[AktForm],-1 ; aktivn formt neplatn
         jmp       short Start613           ; inicializace parametr

; ------ kurzor vpravo

Start64: mov       al,ds:[AktDisk]
         cmp       al,ds:[NumDisk]
         jae       Start632
         inc       ax
         jmp       short Start632

; ------ Shift-Tab

Start65: mov       al,ds:[AktDisk]
         dec       al
         jns       Start632
         mov       al,ds:[NumDisk]          ; poet disk
         dec       ax                       ; slo poslednho disku
         jmp       short Start632

; ------ Tab

Start66: mov       al,ds:[AktDisk]
         inc       al
         cmp       al,ds:[NumDisk]
         jb        Start632
         mov       al,0
         jmp       short Start632

; ------ formtovn disku

Start7:  call      FormDsk
         jmp       Start5

; ------ volba parametr

Start8:  call      Volby                    ; ovldn voleb
         cmp       byte ptr ds:[MousePoz+1],24
         je        Start82
         and       byte ptr ds:[MouseKey],not b0 ; zruen levho tlatka
         xor       byte ptr ds:[MouseTim+1],1 ; neplatn as
Start82: jmp       Start53

; ------ ESC: konec programu

Start9:  call      MouseOff
         mov       ah,0fh
         call      Int10
         mov       ah,0
         call      Int10
         mov       dl,ds:[OldBreak]         ; pvodn pznak peruen
         mov       ax,3301h
         int       21h                      ; nvrat pznaku BREAK
         lds       dx,ds:[Old08]
         mov       ax,2508h
         int       21h
         int       20h

; -----------------------------------------------------------------------------
;        stanoven adresy diskovho bufferu (AX=adresa) -> CX
; -----------------------------------------------------------------------------

InitBuff PROC      NEAR

; ------ adresa nejbli vy hranice 64 KB

         mov       bx,ax                    ; aktuln adresa bufferu
         and       bx,not 0fffh             ; zarovnn na 64 KB
         add       bh,10h                   ; adresa dal hranice 64 KB
         jnc       InitBuf1                 ; nen pelom pes 1 MB
         mov       bx,-1                    ; omezen na 1 MB

; ------ kontrola, zda je dost msta pro datov buffer

InitBuf1:mov       cx,bx                    ; nejbli pelom 64 KB
         sub       cx,ax                    ; zbyl msto do 64 KB
         cmp       cx,BUFFSIZE/16           ; sta pro diskov buffer ?
         ja        InitBuf3                 ; velikost pro buffer je dostaten

; ------ test, zda msto sta alespo pro buffer FAT

         cmp       cx,BUFFFAT/16            ; sta alespo pro buffer FAT ?
         jbe       InitBuf2                 ; mlo msta pro buffer FAT
         cmp       word ptr ds:[BufferF],0  ; je buffer FAT ji vytvoen ?
         jne       InitBuf2                 ; buffer FAT je ji vytvoen
         mov       ds:[BufferF],ax          ; adresa bufferu FAT

; ------ posun adresy bufferu na zatek dalho pelomu

InitBuf2:mov       ax,bx                    ; posun zatku bufferu na pelom
InitBuf3:mov       cx,ax                    ; adresa bufferu
         add       ax,BUFFSIZE/16           ; posun adresy
         ret

InitBuff ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 23h a INT 24h
; -----------------------------------------------------------------------------

INT24    PROC      FAR

         mov       al,0
INT23:   iret

INT24    ENDP

; 
;
;                          Formtovn disku
;
; 
;
FormDsk  PROC      NEAR

; ------ instalace INT 1eh

         call      Inst1e                   ; instalace INT 1Eh

; ------ pprava BOOT sektoru

FormDsk0:call      SetSer                   ; nastaven sriovho sla

; ------ inicializace ukazatel

         xor       ax,ax
         mov       byte ptr ds:[AktStop],al ; ukazatel stop
         mov       byte ptr ds:[AktStran],al ; strana
         mov       word ptr ds:[CitVol],ax
         mov       word ptr ds:[CitVol+2],ax
         mov       word ptr ds:[CitBad],ax
         mov       word ptr ds:[CitBad+2],ax
         mov       ds:[ErrDat],al           ; pznak chyby 1. sektoru bloku

;         mov       word ptr ds:[AktSekt],ax ; ukazatel absolutnho sektoru
;         and       byte ptr ds:[Priznaky],not bit0 + bit1 ; nulovn pznak
;         mov       word ptr ds:[VolSekt],ax
;         mov       word ptr ds:[BadSekt],ax
;         mov       word ptr ds:[FrstChar],ax
;         mov       byte ptr ds:[FillCh],0   ; plnic znak pro formtovn

         mov       al,1
         mov       ds:[ErrBoot],al
         mov       ds:[ErrFat1],al
         mov       ds:[ErrFat2],al
         mov       ds:[ErrRoot],al

         mov       al,ds:[ParBack]          ; smr
         mov       ds:[Smer],al             ; smr formtovn
         cmp       al,0
         je        FormDs02
         mov       al,ds:[NumStop]          ; poet stop
         dec       ax
         mov       ds:[AktStop],al          ; posledn stopa
         mov       al,ds:[NumStran]
         dec       ax
         mov       ds:[AktStran],al         ; posledn strana
FormDs02:

; ------ nulovn tabulky FAT

         mov       es,ds:[BufferF]          ; segment bufferu s FAT
         mov       ch,ds:[FatSekt]          ; poet sektor tabulky FAT
         mov       cl,0
         xor       ax,ax
         xor       di,di
         cld
         rep       stosw                    ; nulovn tabulky FAT
         dec       ax
         mov       es:[1],ax                ; zatek tabulky FAT
         mov       al,ds:[Popis]            ; popisova mdia
         mov       es:[0],al                ; popisova mdia

; ------ pprava ukazatele k zobrazen mapy disku

         cmp       byte ptr ds:[NumStran],2 ; jsou 2 strany ?
         je        FormDs21                 ; jsou 2 strany
         mov       al,4                     ; vka - 1 strana 40 stop
         cmp       byte ptr ds:[NumStop],40 ; je 40 stop ?
         je        FormDs22                 ; je 40 stop
         mov       al,9                     ; vka - 1 strana 80 stop
         jmp       short FormDs22           ; je 80 stop

FormDs21:mov       al,5                     ; vka - 2 strany 40 stop
         cmp       byte ptr ds:[NumStop],60 ; je 40 stop ?
         jb        FormDs22                 ; je 40 stop
         mov       al,11                    ; vka - 2 strany 80 stop
FormDs22:mov       byte ptr ds:[SirMap+1],al ; vka mapy disku
         sub       al,11
         neg       al                       ; zbytek na okraje
         shr       al,1
         add       al,11                    ; poten dek
         mov       byte ptr ds:[PozMap+1],al ; poten dek k zobrazen mapy

         mov       al,ds:[NumStop]          ; poet stop
         cmp       al,60
         jb        FormDs23                 ; je 40 stop
         inc       ax                       ; zaokrouhlen nahoru
         shr       al,1                     ; poet stop / 2
FormDs23:add       al,13                    ; korekce na okraje
         mov       byte ptr ds:[SirMap],al  ; ka okna
         sub       al,58
         neg       al
         shr       al,1
         mov       byte ptr ds:[PozMap],al  ; poten pozice okna

; ------ roztoen mechaniky

         xor       bx,bx
         mov       es,bx
         mov       ax,401h
         mov       cx,1
         call      Int13                    ; verifikace pro roztoen mechaniky
         call      ResDisk                  ; vodn reset disku

; ------ nastaven formtu disku

         call      SetForm                  ; nastaven formtu diskety
         jnc       FormDs40
         jmp       FormDsk9


FormDs40:
         call      DispPod                  ; zobrazen podkladu
         call      DispVol                  ; zobrazen voleb

         call      DispMap                  ; zobrazen mapy disky
         call      DispInf                  ; zobrazen informanho okna

         xor       ax,ax
         mov       es,ax
         mov       ax,es:[46ch]
         mov       ds:[BegTime],ax

         mov       byte ptr ds:[ParsTime],1 ; pznak zobrazen doby akce

FormDsk4:

; ------ oznaen tabulky chyb - vechny sektory OK

         push      cs
         pop       es
         mov       di,offset TabBad
         mov       cx,word ptr ds:[NumSekt] ; poet sektor na stopu
         mov       al,0                     ; nulovac hodnota
         cld
         rep       stosb                    ; vymazn tabulky vadnch stop

         cmp       byte ptr ds:[ParDat],0
         je        FormD411

         mov       cl,1
         mov       al,ds:[NumSekt]
         mov       es,ds:[bufferD]
         xor       bx,bx
         call      Cteni
         jc        FormD416

FormD411:
         call      Format
         jc        FormD416

         call      TestRnd                  ; test nhodnm zpisem
         jc        FormD416

         cmp       byte ptr ds:[AktStran],0
         jne       FormD413
         cmp       byte ptr ds:[AktStop],0
         jne       FormD413

         mov       es,ds:[BufferW]
         xor       di,di
         mov       si,offset Boot
         mov       cx,offset(BootEnd-Boot)
         cld
         rep       movsb
         xor       ax,ax
         mov       cx,offset(Boot-BootEnd)+512
         rep       stosb
         mov       al,ds:[Popis]
         stosb
         mov       ax,-1
         stosw
         mov       cx,512-3
         mov       al,0
         rep       stosb
         mov       cl,1
         mov       al,2
         xor       bx,bx
         call      Zapis
         jc        FormD416

FormD413:
         cmp       byte ptr ds:[ParDat],0
         je        FormD412

         mov       cl,1
         mov       al,ds:[NumSekt]
         mov       es,ds:[BufferD]
         xor       bx,bx
         call      Zapis
         jc        FormD416


FormD412:cmp       byte ptr ds:[ParVerif],0
         je        FormD414

         call      Verif                    ; verifikace
         jnc       FormD414

FormD416:
         call      ReadBad                  ; ten vadn stopy
         stc

FormD414:

         mov       ah,ds:[ColOK]
         mov       al,""
         jnc       FormDs42
FormDs41:mov       ah,ds:[ColErr]
         mov       al,"x"
FormDs42:call      DispFCh


         mov       ah,1
         int       16h
         jz        FormDs76
         call      InpKey
         cmp       bl,27
         je        FormDsk9

; ------ zaazen natench sektor

FormDs76:call      StorSekt                 ; zaazen sektor stopy
         call      DispKap                  ; zobrazen kapacit disku

; ------ zven sla stopy

         mov       al,ds:[AktStran]         ; aktuln strana
         cmp       byte ptr ds:[Smer],0
         je        FormDs77                 ; je smr nahoru
         dec       al                       ; snen sla strany
         jz        FormDs78

         mov       al,ds:[AktStop]
         dec       al
         js        FormDs79                 ; jsou ji vechny stopy
         mov       ds:[AktStop],al

         mov       al,ds:[NumStran]
         dec       ax
         jmp       short FormDs78

FormDs77:inc       ax                       ; zven sla aktuln strany
         cmp       al,ds:[NumStran]         ; jsou ji vechny strany ?
         jb        FormDs78                 ; nejsou jet vechny strany

         mov       al,ds:[AktStop]          ; aktuln stopa
         inc       ax                       ; zven sla stopy
         cmp       al,ds:[NumStop]          ; jsou ji vechny stopy ?
         jae       FormDs79                 ; jsou ji vechny stopy
         mov       ds:[AktStop],al          ; aktuln stopa
         mov       al,0                     ; strana 0
FormDs78:mov       ds:[AktStran],al         ; aktuln strana

         jmp       FormDsk4                 ; formtovn dal stopy

FormDs79:


FormDsk8:

         mov       byte ptr ds:[ParsTime],0 ; zruen pznaku zobrazen asu
         call      InpKey

FormDsk9:

         call      DeInst1E                 ; odinstalovn INT 1eh
         mov       byte ptr ds:[ParsTime],0 ; zruen pznaku zobrazen asu

         ret

FormDsk  ENDP

; -----------------------------------------------------------------------------
;        test stopy nhodnm zpisem
; -----------------------------------------------------------------------------

TestRnd  PROC      NEAR

; ------ kontrola, zda se provdj testovac zpisy

         mov       al,ds:[ParTest]          ; poet testovacch zpis
         cmp       al,0                     ; jsou testovac zpisy ?
         jne       TestRnd1                 ; jsou testovac zpisy
         ret

; ------ pprava registr

TestRnd1:mov       ah,0
         mov       bp,ax                    ; ta testovacch zpis

; ------ je-li posledn zpis, je nulovac konstanta

TestRnd2:mov       es,ds:[BufferW]          ; buffer k zpisu
         xor       di,di                    ; potek bufferu
         mov       cx,word ptr ds:[NumSekt] ; poet sektor na stopu
         cmp       bp,1                     ; je posledn zpis
         jne       TestRnd3                 ; nen posledn zpis
         mov       ch,cl                    ; poet sektor
         mov       cl,0                     ; CX = poet slov dat
         mov       al,ds:[ParChar]          ; nulovac konstanta
         mov       ah,al
         cld
         rep       stosw                    ; vymazn dat
         jmp       short TestRnd4

; ------ pprava dat k zpisu - nhodn data

TestRnd3:call      RandomS                  ; vygenerovn sektoru
         loop      TestRnd3                 ; dal sektor

; ------ zpis dat na disk

TestRnd4:mov       al,ds:[NumSekt]          ; poet sektor k zpisu
         mov       cl,1                     ; poten sektor
         xor       bx,bx                    ; potek dat
         call      Zapis                    ; zpis dat na disk
         jc        TestRnd9                 ; chyba dat

; ------ kontroln ten dat

         mov       al,ds:[NumSekt]
         mov       cl,1
         xor       bx,bx
         mov       es,ds:[BufferR]          ; tec buffer
         call      Cteni
         jc        TestRnd9

; ------ porovnn dat

         push      ds
         mov       ch,ds:[NumSekt]
         mov       cl,0
         mov       ds,ds:[BufferW]
         xor       si,si
         xor       di,di
         cld
         repe      cmpsw                    ; porovnn dat
         pop       ds
         stc
         jne       TestRnd9                 ; data nesouhlas

         dec       bp
         jnz       TestRnd2                 ; dal zpis
         clc

TestRnd9:ret

TestRnd  ENDP

; -----------------------------------------------------------------------------
;        naten BOOT sektoru
; -----------------------------------------------------------------------------

ReadBoot PROC      NEAR






         ret

ReadBoot ENDP

; -----------------------------------------------------------------------------
;        instalace obsluhy INT 1eh
; -----------------------------------------------------------------------------

Inst1e   PROC      NEAR

; ------ schova adresy INT 1eh

         mov       ax,351eh
         int       21h
         mov       word ptr ds:[Old1e],bx
         mov       word ptr ds:[Old1e+2],es

; ------ instalace nov adresy INT 1eh

         mov       ax,251eh
         mov       dx,offset Int1e
         int       21h
         ret

Inst1e   ENDP

; -----------------------------------------------------------------------------
;        odinstalovn INT 1eh
; -----------------------------------------------------------------------------

DeInst1e PROC      NEAR

         push      ds
         mov       ax,251eh
         lds       dx,ds:[Old1e]
         int       21h                      ; nvrat INT 1eh
         pop       ds
         ret

DeInst1e ENDP

; -----------------------------------------------------------------------------
;        nastaven sriovho sla
; -----------------------------------------------------------------------------

SetSer   PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ stanoven systmovho asu

         mov       ah,2ch
         int       21h                      ; poskytnut systmovho asu

         mov       ah,0
         mov       al,dl                    ; setina sekundy 7 bit
         shr       al,1                     ; setina sekundy 6 bit

         mov       dl,0
         shr       dx,1
         shr       dx,1
         or        ax,dx                    ; sekunda 6 bit (pesahuj 4 bity)

         mov       dh,0
         mov       dl,cl                    ; minuta
         mov       cl,4                     ; poet rotac
         shl       dx,cl
         or        ah,dl                    ; minuty 4 bity
         mov       dl,dh                    ; minuty 2 bity

         mov       dh,ch                    ; hodina
         shl       dh,1
         shl       dh,1
         or        dl,dh                    ; hodina 5 bit (zbv 1 bit)
         mov       dh,0

         mov       word ptr ds:[BSerie+2],ax
         mov       word ptr ds:[BSerie],dx  ; v DX je 7 bit

; ------ stanoven systmovho data

         mov       ah,2ah
         int       21h                      ; poskytnut systmovho data

         mov       ah,dh                    ; msc
         mov       cl,4
         shl       ah,cl                    ; msc 4 bity
         mov       dh,0
         mov       cl,7
         shl       dx,cl                    ; den 5 bit
         or        ax,dx                    ; msc + den
         or        word ptr ds:[BSerie],ax  ; + msc a den

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

SetSer   ENDP

; -----------------------------------------------------------------------------
;        zaazen sektor stopy
; -----------------------------------------------------------------------------

StorSekt PROC      NEAR

; ------ pprava registr

         mov       cx,word ptr ds:[NumSekt] ; poet sektor na stopu
         mov       si,offset TabBad         ; tabulka vadnch sektor
         mov       al,ds:[AktStop]          ; aktuln stopa
         mul       byte ptr ds:[NumStran]   ; poet ji zpracovanch stop
         add       al,ds:[AktStran]         ; piten aktuln strany
         mul       cl                       ; absolutn slo sektoru stopy
         xchg      ax,bx                    ; BX <- ukazatel sla sektoru

; ------ naten parametr sektoru

StorSkt1:cld
         lodsb                              ; naten sektoru
         push      bx

; ------ oznaen sektoru BOOT

         sub       bx,1                     ; je BOOT sektor ?
         ja        StorSkt2                 ; nen BOOT sektor
         je        StorSk22
         mov       ds:[ErrBoot],al          ; pznak BOOT sektoru
         jmp       short StorSkt9

; ------ oznaen sektoru FAT 1

StorSk22:mov       ds:[ErrFat1],al
StorSkt2:sub       bx,word ptr ds:[FatSekt] ; odeten sektor FAT 1
         ja        StorSkt3
         je        StorSk32
         or        ds:[ErrFat1],al          ; pznak FAT 1
         jmp       short StorSkt9

; ------ oznaen sektoru FAT 2

StorSk32:mov       ds:[ErrFat2],al
StorSkt3:sub       bx,word ptr ds:[FatSekt] ; odeten sektor FAT 2
         ja        StorSkt4
         je        StorSk42
         or        ds:[ErrFat2],al          ; pznak FAT 2
         jmp       short StorSkt9

; ------ oznaen sektoru ROOT

StorSk42:mov       ds:[ErrRoot],al
StorSkt4:sub       bx,word ptr ds:[RootSekt] ; odeten sektor na ROOT
         jae       StorSkt5
         or        ds:[ErrRoot],al          ; pznak ROOT
         jmp       short StorSkt9

; ------ vadn data - oznaen sektoru v tabulce FAT

StorSkt5:cmp       al,0                     ; je sektor OK ?
         je        StorSk52                 ; sektor je OK
         push      ax
         push      bx
         cmp       byte ptr ds:[BlokSekt],1
         je        StorSk51
         shr       bx,1                     ; sektor / 2
StorSk51:mov       ax,0ff7h
         inc       bx
         inc       bx                       ; zan se od bloku 2
         call      SetFat                   ; oznaen vadnho bloku BX ve FAT
         pop       bx
         pop       ax

; ------ zven tae dat

StorSk52:cmp       byte ptr ds:[BlokSekt],1 ; je 1 sektor na blok ?
         je        StorSkt7                 ; je 1 sektor na blok
         test      bl,1                     ; je lich datov sektor ?
         jnz       StorSkt6                 ; je lich datov sektor
         mov       ds:[ErrDat],al           ; schova pznaku sektoru
         jmp       short StorSkt9
StorSkt6:or        al,ds:[ErrDat]           ; slouen se sudm sektorem
StorSkt7:cmp       al,0                     ; je blok OK ?
         mov       ax,ds:[BlokByte]         ; poet bajt na alokan blok
         je        StorSkt8                 ; blok je OK
         add       word ptr ds:[CitBad],ax  ; ta vadnch blok
         adc       word ptr ds:[CitBad+2],0
         jmp       short StorSkt9

StorSkt8:add       word ptr ds:[CitVol],ax  ; ta volnch blok
         adc       word ptr ds:[CitVol+2],0

; ------ pprava pro dal sektor

StorSkt9:pop       bx
         inc       bx
         dec       cx
         jz        StorSktA
         jmp       StorSkt1                 ; dal sektor
StorSktA:ret

StorSekt ENDP

; -----------------------------------------------------------------------------
;        nastaven poloky BX v tabulce FAT na hodnotu AX
; -----------------------------------------------------------------------------

SetFat   PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      ds

; ------ stanoven adresy poloky ve FAT tabulce

         mov       cx,bx                    ; slo bloku
         shr       bx,1                     ; slo bloku / 2
         add       bx,cx                    ; slo bloku * 1.5
         mov       ds,ds:[BufferF]          ; buffer s tabulkou FAT

; ------ nastaven hodnoty FAT - sud poloka

         test      cl,1                     ; je sud poloka ?
         jnz       SetFat3                  ; je lich poloka
         and       word ptr ds:[bx],0f000h  ; nulovn star hodnoty
         jmp       short SetFat4

; ------ nastaven hodnoty FAT - lich poloka

SetFat3: and       word ptr ds:[bx],0fh     ; nulovn star hodnoty
         mov       cl,4                     ; poet rotac
         shl       ax,cl                    ; rotace hodnoty na pozici
SetFat4: or        ds:[bx],ax               ; nastaven nov hodnoty

; ------ nvrat registr

SetFat9: pop       ds
         pop       cx
         pop       bx
         pop       ax
         ret

SetFat   ENDP

; 
;
;                              Obsluha disku
;
; 
;
; -----------------------------------------------------------------------------
;        naten obsahu vadn stopy
; -----------------------------------------------------------------------------

ReadBad  PROC      NEAR

; ------ inicializace tabulky vadnch stop

         push      ds
         pop       es
         mov       di,offset TabBad         ; tabulka vadnch stop
         mov       cx,word ptr ds:[NumSekt] ; poet sektor na stopu
         mov       al,-1                    ; nulovac hodnota
         cld
         rep       stosb                    ; vymazn tabulky vadnch stop

; ------ pprava ukazatel

         cmp       byte ptr ds:[ParOptim],0 ; dl se optimalizace chyb ?
         je        ReadBad9                 ; optimalizace se nedl
         mov       es,ds:[BufferR]          ; buffer pro ten
         mov       dh,0
         mov       ch,ds:[NumSekt]          ; poet sektor na stopu

; ------ pprava ukazatel pro ten skupiny blok velikosti CL

ReadBad3:shr       ch,1
         adc       ch,0                     ; polovina potu sektor
         shr       ch,1
         adc       ch,0                     ; tvrtina potu sektor
         mov       cl,1                     ; slo potenho sektoru
         xor       bx,bx                    ; adresa zatku bufferu
         mov       di,offset TabBad         ; tabulka vadnch sektor

; ------ stanoven skutenho potu zbylch sektor

ReadBad4:mov       dl,ch                    ; DH <- poet sektor ke ten
         add       dl,cl                    ; slo dalho sektoru
         cmp       dl,ds:[NumSekt]          ; peteen potu sektor ?
         jbe       ReadBad5                 ; slo sektoru je OK
         mov       dl,ds:[NumSekt]          ; omezen max. sla sektoru
         inc       dx                       ; nsledujc sektor
ReadBad5:sub       dl,cl                    ; poet sektor ke ten

; ------ test, zda je poteba st zvolenou skupinku sektor

         push      cx
         push      di
         push      es
         push      cs
         pop       es                       ; ES <- CS
         mov       al,-1                    ; hledan vadn sektor
         mov       cx,dx                    ; poet sektor ke ten
         cld
         repne     scasb                    ; nalezen vadnho sektoru
         pop       es
         pop       di
         pop       cx
         jne       ReadBad7                 ; vadn sektor nen, nen teba st

; ------ naten jedn skupinky sektor

         push      cx
         push      dx
         xchg      ax,dx                    ; AL <- poet sektor ke ten
         call      Cteni                    ; ten jedn skupiny sektor
         pop       dx
         pop       cx
         jc        ReadBad7                 ; ten nespn

; ------ pi spnm ten nulovn petench sektor

         push      cx
         push      es
         push      di
         push      cs
         pop       es
         cld
         mov       al,0
         mov       cx,dx                    ; poet natench sektor
         rep       stosb                    ; vynulovn petench sektor
         pop       di
         pop       es
         pop       cx

; ------ zven ukazatele sektor

ReadBad7:add       bh,ch
         add       bh,ch                    ; zven adresy dat v bufferu
         add       di,dx                    ; zven ukazatele v tabulce chyb
         add       cl,dl                    ; zven ukazatele sektor
         cmp       cl,ds:[NumSekt]          ; jsou ji vechny sektory ?
         jbe       ReadBad4                 ; ten dal skupinky sektor

; ------ pprava pro ten jemnjho dlen skupin

         cmp       ch,1                     ; byl ji 1 sektor ?
         jne       ReadBad3                 ; ten dalho dlen sektor
ReadBad9:ret

ReadBad  ENDP

; -----------------------------------------------------------------------------
;        pprava parametr aktivnho disku
; -----------------------------------------------------------------------------

IniDPar  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si

; ------ pprava ukazatele aktivnho disku

         mov       bl,ds:[AktDisk]          ; aktivn disk
         cmp       bl,ds:[NumDisk]          ; je platn slo disku ?
         jb        IniDPar1                 ; slo aktivnho disku je OK
         mov       bl,ds:[NumDisk]          ; poet disk
         dec       bx                       ; omezen na posledn disk
         mov       ds:[AktDisk],bl          ; nov aktivn disk
IniDPar1:mov       bh,0

; ------ schova aktivnho formtu aktivnho disku

         mov       al,ds:[AktForm]          ; aktivn formt
         cmp       al,-1                    ; je aktivn formt platn ?
         je        IniDPar2                 ; aktivn formt nen platn
         mov       ds:[AktFormT+bx],al      ; schova aktivnho formtu

; ------ tabulka definice formt disku

IniDPar2:mov       al,ds:[TypDiskT+bx]      ; typ aktivnho disku
         mov       ds:[TypDisk],al          ; typ aktivnho disku
         mov       ah,0
         shl       ax,1                     ; typ aktivnho disku * 2
         xchg      ax,si                    ; SI <- typ aktivnho disku * 2
         mov       si,ds:[TabForm+si-2]     ; adresa definice formtu disku

; ------ poet formt disku

         mov       ah,ds:[si]               ; poet platnch formt disku
         mov       ds:[NumForm],ah          ; poet formt disku
         inc       si                       ; adresa prvnho formtu

; ------ nvrat aktivnho formtu disku

         mov       al,ds:[AktFormT+bx]      ; aktivn formt aktivnho disku
         cmp       al,ah                    ; je slo formtu platn ?
         jb        IniDPar3                 ; slo formtu je platn
         mov       al,ah                    ; omezen sla formtu
         dec       al
IniDPar3:mov       ds:[AktForm],al          ; aktivn formt

; ------ adresa aktivnho formtu disku

;         dec       al                       ; aktivn formt - 1
;         jns       IniDPar4
;         jmp       IniDPar9                 ; je automatick formt
IniDPar4:mov       ah,FORMOFFS              ; dlka definice jednoho formtu
         mul       ah                       ; offset aktivnho formtu
         add       si,ax                    ; adresa aktivnho formtu

; ------ poet stop

         mov       al,39                    ; 40 stop
         test      byte ptr ds:[si+0],b0    ; je 80 stop ?
         jz        IniDPr41                 ; je 40 stop
         mov       al,79                    ; jinak 80 stop
IniDPr41:mov       ds:[TypStop],al          ; jmenovit poet stop - 1
         inc       ax                       ; jmenovit poet stop
         add       al,ds:[ParStop]          ; piten doplujcch stop
         mov       ds:[NumStop],al          ; poet stop

; ------ poet stran

         mov       al,1                     ; 1 strana
         cmp       byte ptr ds:[ParStra],0  ; je 1 strana ?
         jne       IniDPr42                 ; je 1 strana
         mov       al,2                     ; 2 strany
IniDPr42:mov       ds:[NumStran],al         ; poet stran

; ------ pznak dvojitho krokovn

         mov       al,1                     ; pznak dvojitho krokovn
         test      byte ptr ds:[si+0],b2    ; je dvojit krokovn ?
         jnz       IniDPr43                 ; je dvojit krokovn
         mov       al,0                     ; nen dvojit krokovn
IniDPr43:mov       ds:[Krokov],al           ; pznak dvojitho krokovn

; ------ poet sektor na blok

         mov       al,1                     ; 1 sektor na blok
         cmp       byte ptr ds:[NumStran],1 ; je 1 strana ?
         je        IniDPr44                 ; je 1 strana
         test      byte ptr ds:[si+0],b1    ; 2 sektory na blok ?
         jz        IniDPr44                 ; 1 sektor na blok
         mov       al,2                     ; 2 sektory na blok
IniDPr44:mov       ds:[BlokSekt],al         ; poet sektor na blok

; ------ poet sektor na stopu

         mov       al,ds:[si+1]             ; poet sektor na stopu
         mov       ds:[NumSekt],al          ; poet sektor na stopu

; ------ odsazen sektor SLIDING

         mov       byte ptr ds:[SlidX],0    ; vypnut funkce Sliding
         mov       byte ptr ds:[SlidY],0
         test      byte ptr ds:[si+0],b5    ; provd se SLIDING ?
         jz        IniDP444                 ; SLIDING se neprovd
         cmp       al,13                    ; je disketa HD ?
         mov       al,1                     ; SLIDING pro disketu DD = 1
         jbe       IniDP442                 ; je disketa DD
         inc       ax                       ; SLIDING pro disketu HD = 2
IniDP442:mov       ds:[SlidX],al            ; Sliding stran
         inc       ax
         mov       ds:[SlidY],al            ; Sliding stop

; ------ faktor prokldn sektor

IniDP444:mov       al,1                     ; faktor prokldn = 1
         test      byte ptr ds:[si+0],b4    ; je prokldn sektor = 2 ?
         jz        IniDP445                 ; je prokldn = 1
         inc       ax                       ; faktor prokldn = 2
IniDP445:mov       ds:[Inter],al            ; faktor prokldn sektor

; ------ poet sektor na ROOT

         mov       al,ds:[si+2]             ; poet sektor na ROOT
         cmp       byte ptr ds:[NumStran],1 ; je 1 strana ?
         jne       IniDPr45                 ; jsou 2 strany
         shr       al,1                     ; poet sektor/2
         adc       al,0                     ; penos CF
IniDPr45:cmp       byte ptr ds:[ParRoot],0  ; zadn poet poloek na ROOT ?
         je        IniDPr46                 ; nen zadn poet poloek na Root
         mov       byte ptr ds:[BlokSekt],1 ; vdy je 1 sektor na blok
         mov       al,ds:[ParRoot]          ; poet poloek na ROOT
IniDPr46:mov       ds:[RootSekt],al         ; poet sektor na ROOT
         mov       ah,0
         shl       ax,1
         shl       ax,1
         shl       ax,1
         shl       ax,1
         mov       ds:[RootMax],ax          ; poet poloek na ROOT

; ------ popisova mdia

         mov       al,ds:[si+3]             ; popisova mdia
         cmp       byte ptr ds:[NumStran],1 ; je 1 strana ?
         je        IniDPr47                 ; je 1 strana
         or        al,1                     ; korekce pro 2 strany
IniDPr47:mov       ds:[Popis],al            ; popisova mdia

; ------ celkov poet sektor mdia

         mov       al,ds:[NumSekt]          ; poet sektor na stopu
         mul       byte ptr ds:[NumStran]   ; vynsoben potem stran
         mul       byte ptr ds:[NumStop]    ; vynsoben potem sektor
         mov       ds:[CelkSekt],ax         ; celkov poet sektor mdia

; ------ pprava k nalezen dostatenho potu sektor na FAT

         mov       byte ptr ds:[FatSekt],1  ; vchoz hodnota - 1 sektor na FAT

; ------ poet alokanch blok

IniDPar5:mov       ax,ds:[CelkSekt]         ; celkov poet sektor
         dec       ax                       ; odeten BOOT sektoru
         mov       bh,0
         mov       bl,ds:[FatSekt]          ; poet sektor na FAT
         sub       ax,bx                    ; odeten sektor na FAT 1
         sub       ax,bx                    ; odeten sektor na FAT 2
         sub       al,ds:[RootSekt]         ; odeten sektor na ROOT
         sbb       ah,0
         xor       dx,dx
         mov       bl,ds:[BlokSekt]         ; poet sektor na alokan blok
         div       bx                       ; vpoet potu alokanch blok
         mov       ds:[CelkBlok],ax         ; celkov poet alokanch blok

; ------ vpoet kapacity tabulek FAT

         mov       ah,ds:[FatSekt]          ; poet sektor na FAT
         mov       al,0
         shl       ax,1                     ; poet bajt na FAT
         shl       ax,1                     ; poet tetrd
         xor       dx,dx
         mov       bl,3                     ; poet tetrd na poloku FAT
         div       bx                       ; vpoet potu poloek FAT
         sub       ax,2 + 16                ; odeten rezervovanch hodnot

; ------ kontrola, zda je poet poloek FAT postaujc

         cmp       ax,ds:[CelkBlok]         ; sta poet poloek FAT ?
         jae       IniDPar6                 ; poet poloek FAT je postaujc
         inc       byte ptr ds:[FatSekt]    ; zven potu poloek FAT
         jmp       short IniDPar5           ; nov test

; ------ poet bajt na alokan blok

IniDPar6:mov       ah,ds:[BlokSekt]         ; poet sektor na alokan blok
         mov       al,0
         shl       ax,1                     ; poet sektor * 512 bajt
         mov       ds:[BlokByte],ax         ; poet bajt na alokan blok

; ------ vpoet celkov kapacity disku

         mov       ax,ds:[CelkBlok]         ; celkov poet alokanch blok
         mul       word ptr ds:[BlokByte]   ; vynsoben potem bajt na blok
         mov       word ptr ds:[CelkKap],ax ; celkov kapacita LOW
         mov       word ptr ds:[CelkKap+2],dx ; celkov kapacita HIGH

; ------ nvrat registr

IniDPar9:pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

IniDPar  ENDP

; -----------------------------------------------------------------------------
;        stanoven potu a typ disketovch mechanik
; -----------------------------------------------------------------------------

GetDTyp  PROC      NEAR

; ------ stanoven potu disketovch mechanik v systmu

         push      ds
         int       11h                      ; poskytnut vpisu vybaven
         pop       ds
         test      al,b0                    ; je v systmu njak mechanika ?
         jz        GetDTyp9                 ; v systmu nen dn mechanika
         rol       al,1
         rol       al,1
         and       al,3                     ; poet disketovch mechanik - 1
         inc       ax                       ; poet disketovch mechanik
         mov       ds:[NumDisk],al          ; poet disketovch mechanik

; ------ stanoven typ jednotlivch disk

         mov       si,offset TypDiskT       ; tabulka typ disk
         mov       dl,0                     ; ukazatel sla disku

GetDTyp1:push      dx
         push      si

         mov       ax,86eh                  ; funkce 8, AL=nesmysl pro kontrolu
         xor       cx,cx                    ; pednastaven nesmysl
         mov       bl,0                     ; pednastaven - neznm typ
         call      Int13                    ; poskytnut parametr disku

         pop       si
         pop       dx

; ------ stanoven typu disku

         or        ax,ax
         jnz       GetDTyp3                 ; funkce nen podporovan
         cmp       bl,0                     ; je typ mechaniky znm ?
         je        GetDTyp2                 ; typ mechaniky nen znm
         cmp       bl,5
         jbe       GetDTyp4                 ; typ mechaniky je OK
GetDTyp2:cmp       ch,79                    ; je 80 stop ?
         jb        GetDTyp3                 ; je asi mechanika 360 KB
         mov       bl,3                     ; mechanika 702 KB
         cmp       cl,13
         jbe       GetDTyp4                 ; mechanika 720 KB
         mov       bl,2                     ; mechanika 1.2 MB
         cmp       cl,16
         jbe       GetDTyp4                 ; mechanika 1.2 MB
         mov       bl,4                     ; mechanika 1.44 MB
         cmp       cl,20
         jbe       GetDTyp4                 ; mechanika 1.44 MB
         mov       bl,5                     ; jinak mechanika 2.88 MB
         jmp       short GetDTyp4

; ------ pprava pro dal disk

GetDTyp3:mov       bl,1                     ; mechanika 360 KB
GetDTyp4:mov       ds:[si],bl               ; typ disketov mechaniky
         inc       si                       ; zven ukazatele v tabulce
         inc       dx                       ; zven sla disku
         cmp       dl,ds:[NumDisk]          ; jsou ji vechny disky ?
         jb        GetDTyp1                 ; stanoven dalho disku

GetDTyp9:ret

GetDTyp  ENDP

; -----------------------------------------------------------------------------
;        zformtovn aktuln stopy (CY=chyba, AH=kd chyby)
; -----------------------------------------------------------------------------

Format   PROC      NEAR

; ------ zobrazen indiktoru formtovn

         mov       al,"F"
         mov       ah,ds:[ColForm]          ; barva
         call      DispFCh                  ; zobrazen indiktoru

; ------ stanoven sla potenho sektoru

         mov       al,ds:[SlidX]            ; odsazen sektor stran
         add       al,ds:[SlidY]            ; selkov odsazen na stopu
         mul       byte ptr ds:[AktStop]    ; posun odsazenm pedelch stop
         cmp       byte ptr ds:[AktStran],0 ; je strana 0 ?
         je        Format02                 ; je strana 0
         add       al,ds:[SlidX]            ; jet jedno odsazen strany
         adc       ah,0                     ; penos
Format02:div       byte ptr ds:[NumSekt]    ; maskovn MOD poet sektor
         mov       al,ah                    ; poten slo sektoru - 1
         inc       ax                       ; poten slo sektoru

; ------ pprava registr ke generovn tabulky

         clc
         xor       di,di
         mov       es,ds:[BufferW]          ; zpisov buffer
         mov       dl,ds:[AktStop]          ; aktuln formtovan stopa
         mov       dh,ds:[AktStran]         ; aktuln formtovan strana
         mov       ah,2                     ; velikost sektoru
         mov       ch,0
         mov       cl,ds:[NumSekt]          ; poet sektor na stopu
         mov       bp,cx                    ; poet sektor na stopu
         shl       bp,1
         shl       bp,1                     ; * 4 = offset konce tabulky
         mov       bl,ds:[Inter]            ; faktor prokldn
         mov       bh,0
         dec       bx
         shl       bx,1
         shl       bx,1                     ; faktor prokldn * 4 - 4

; ------ generovn definin tabulky stopy

Format1: xchg      ax,dx
         stosw                              ; slo vlce a hlavy
         xchg      ax,dx
         stosw                              ; slo a velikost sektoru
         add       di,bx                    ; korekce prokldn
         inc       ax                       ; zven sla stopy
         cmp       al,ds:[NumSekt]          ; pekroeno slo sektoru ?
         jbe       Format2                  ; slo sektoru je OK
         mov       al,1                     ; korekce na sektor 1
Format2: cmp       di,bp                    ; pekroen konec tabulky ?
         jb        Format3                  ; adresa je OK
         mov       di,4                     ; korekce adresy na 2. sektor
Format3: loop      Format1

; ------ formtovn stopy

         mov       ah,5
         inc       cl                       ; poten slo sektoru = 1
         mov       al,ds:[NumSekt]          ; poet sektor
         xor       bx,bx                    ; adresa tabulky definice sektor
         mov       dl,ds:[AktDisk]          ; aktivn disk
         mov       ch,ds:[AktStop]          ; aktuln stopa
         call      Int13                    ; formtovn stopy
         ret

Format   ENDP

; -----------------------------------------------------------------------------
;     ten AL sektor od sektoru CL do bufferu ES:BX -> CY chyba, AH=kd chyby
; -----------------------------------------------------------------------------

Cteni    PROC      NEAR

; ------ zobrazen indiktoru

         push      ax
         mov       al,"R"
         mov       ah,ds:[ColRead]          ; barva
         call      DispFCh                  ; zobrazen indiktoru
         pop       ax

; ------ ten dat z disku

         mov       ah,2
         mov       ch,ds:[AktStop]          ; slo vlce
         mov       dh,ds:[AktStran]         ; slo strany
         call      Int130                   ; zpis dat na disk
         ret

Cteni    ENDP

; -----------------------------------------------------------------------------
;     zpis AL sektor od sektoru CL z bufferu ES:BX -> CY chyba, AH=kd chyby
; -----------------------------------------------------------------------------

Zapis    PROC      NEAR

; ------ zobrazen indiktoru

         push      ax
         mov       al,"W"
         mov       ah,ds:[ColWrite]         ; barva
         call      DispFCh                  ; zobrazen indiktoru
         pop       ax

; ------ zpis dat na disk

         mov       ah,3
         mov       ch,ds:[AktStop]          ; slo vlce
         mov       dh,ds:[AktStran]         ; slo strany
         call      Int130                   ; zpis dat na disk
         ret

Zapis    ENDP

; -----------------------------------------------------------------------------
;        verifikace dat diskety (CY=chyba, AH=kd chyby)
; -----------------------------------------------------------------------------

Verif    PROC      NEAR

; ------ zobrazen indiktoru

         mov       al,"V"
         mov       ah,ds:[ColVerif]         ; barva
         call      DispFCh                  ; zobrazen indiktoru

; ------ verifikace stopy z disku

         xor       bx,bx                    ; offset adresy
         mov       es,bx
         mov       al,ds:[NumSekt]          ; poet sektor
         mov       ah,4
         mov       ch,ds:[AktStop]          ; slo vlce
         mov       cl,1                     ; poten slo sektoru
         mov       dh,ds:[AktStran]         ; strana
         call      Int130                   ; ten dat z disku
         ret

Verif    ENDP

; -----------------------------------------------------------------------------
;        nastaven formtu diskety pro formtovn (CY=chyba, AH=kd chyby)
; -----------------------------------------------------------------------------

SetForm  PROC      NEAR

; ------ nastaven formtu slubou 18h

         mov       bp,3                     ; poet pokus
SetForm1:mov       ah,18h
         mov       ch,ds:[TypStop]          ; jmenovit poet stop disku
         mov       cl,ds:[NumSekt]          ; max. poet sektor
         cmp       cl,8
         jne       SetForm3
         mov       cl,9
SetForm3:call      Int13                    ; nastaven formtu diskety
         jnc       SetForm4
         cmp       ah,1
         je        SetForm5                 ; funkce nepodporovan

         call      ResDisk
         dec       bp
         jnz       SetForm1                 ; dal pokus
         stc
         jmp       short SetForm9           ; chyba

; ------ inicializace tabulky parametr

SetForm4:mov       bl,cl
         mov       cx,12
         push      ds
         push      ds
         push      es
         pop       ds
         pop       es
         mov       si,di
         mov       di,offset Int1e
         rep       movsb                    ; schova tabulky parametr
         pop       ds
         mov       cl,bl

SetForm5:mov       bl,cl
         mov       si,offset Int1e
         mov       byte ptr ds:[si+2],4     ; as pro vypnut motoru
         mov       byte ptr ds:[si+3],2     ; velikost sektoru 512 bajt
         mov       byte ptr ds:[si+4],bl    ; poet sektor na stopu
         mov       byte ptr ds:[si+8],0     ; plnic znak formtovn
         clc                                ; pznak operace OK

SetForm9:
         ret

SetForm  ENDP

; -----------------------------------------------------------------------------
;        reset diskovho systmu
; -----------------------------------------------------------------------------

ResDisk  PROC      NEAR

         push      ax
         mov       ah,0
         call      Int130
         pop       ax
         ret

ResDisk  ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 13 s schovou vech registr
; -----------------------------------------------------------------------------

Int130   PROC      NEAR

         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      es

         call      Int13

         pop       es
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         ret

Int130   ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 13 s schovou registr
; -----------------------------------------------------------------------------

Int13    PROC      NEAR

         push      bp
         push      ds

         sti
         mov       dl,ds:[AktDisk]          ; aktivn disk
         int       13h

         pop       ds
         pop       bp
         ret

Int13    ENDP

; 
;
;                               Volby parametr
;
; 
;
; -----------------------------------------------------------------------------
;        volby parametr
; -----------------------------------------------------------------------------

Volby    PROC      NEAR

; ------ zobrazen voleb

         mov       byte ptr ds:[AktVolby],1 ; pznak aktivnch voleb
         call      DispVol                  ; zobrazen voleb
         call      DispADsk                 ; zobrazen disk
         call      KurzOff

; ------ vstup z ovladae myi

Volby1:  call      MouseGet                 ; test myi
         cmp       bl,4
         jne       Volby11
         jmp       Volby7                   ; stisk pravho tlatka
Volby11: cmp       bl,6
         je        Volby12                  ; druh stisk levho tlatka
         cmp       bl,3
         je        Volby12                  ; stisk levho tlatka
         test      byte ptr ds:[MouseKey],b0 ; je lev tlatko stisknuto ?
         je        Volby5                   ; nen lev tlatko stisknuto
         jmp       short Volby22            ; vodn kurzoru po polokch

; ------ test, zda je ovldn npovdy

Volby12: cmp       dh,24
         jne       Volby2
         cmp       dl,42
         jb        Volby5                   ; neplatn klvesa
         mov       bx,0dh
         cmp       dl,54
         jbe       Volby6                   ; ENTER
         cmp       dl,65
         jbe       Volby7                   ; ESC
         mov       bx,3b00h
         jmp       short Volby6             ; jinak F1

; ------ test, zda je platn dek poloek

Volby2:  cmp       dh,9
         ja        Volby7                   ; peruen voleb
Volby22: cmp       dh,3
         jb        Volby5
         cmp       dh,7
         ja        Volby5

; ------ rozlien sloupce poloek

         or        dl,dl
         jz        Volby5
         cmp       dl,79
         je        Volby5
         cmp       dl,25
         jae       Volby3
         mov       dl,4
         jmp       short Volby4
Volby3:  cmp       dl,50
         mov       dl,28
         jb        Volby4
         mov       dl,53

; ------ test, zda je platn poloka

Volby4:  call      SrcPol
         jc        Volby5                   ; nen platn poloka
         cmp       bl,3
         je        Volby42
         cmp       bl,6
         je        Volby42
         cmp       al,ds:[AktVol]
         je        Volby5
         mov       ds:[AktVol],al           ; slo nov aktivn poloky
         call      DispVol
         jmp       short Volby5

Volby42: mov       ds:[AktVol],al           ; slo nov aktivn poloky
         call      DispVol
         mov       bx,0dh                   ; klvesa ENTER
         jmp       short Volby6             ; zmna poloky

; ------ vstup znaku z klvesnice

Volby5:  call      TestKey
         jnc       Volby52
Volby51: jmp       Volby1                   ; ekn na stisk klvesy

Volby52: call      InpKey
         cmp       bl,1bh
         je        Volby7                   ; peruen ESC

Volby6:  call      EditVol                  ; editace voleb
         jmp       short Volby51            ; dal klvesa

; ------ zobrazen voleb

Volby7:  mov       byte ptr ds:[AktVolby],0 ; pznak aktivnch voleb
         call      IniDPar                  ; inicializace diskovch parametr
         call      DispVol                  ; zobrazen voleb
         call      DispADsk                 ; zobrazen disk
         ret

Volby    ENDP

; -----------------------------------------------------------------------------
;        editace voleb (BX=klvesa)
; -----------------------------------------------------------------------------

EditVol  PROC      NEAR

         mov       al,ds:[AktVol]
         call      GetPol
         mov       di,ds:[si+1]
         mov       al,ds:[di]
         mov       dx,ds:[si+3]
         mov       cl,ds:[si+6]

         call      JumpBX                   ; obsluha klvesy BX

         dw        5100h,EditVl41           ; Page Down
         dw        4900h,EditVl30           ; Page Up
         dw        4f00h,EditVl82           ; End
         dw        4700h,EditVl72           ; Home
         dw        0f00h,EditVol8           ; Shift-Tab
         dw        9,EditVol7               ; Tabeltor
         dw        4d00h,EditVol6           ; vpravo
         dw        4b00h,EditVol5           ; vlevo
         dw        4800h,EditVol8           ; nahoru
         dw        5000h,EditVol7           ; dol
         dw        20h,EditVol2             ; mezera
         dw        0dh,EditVol2             ; ENTER
         dw        0,EditVol1

EditVol1:ret

; ------ mezera, Enter

EditVol2:test      byte ptr ds:[si+0],b0
         jz        EditVl22
         cmp       al,0
         mov       al,0
         jne       EditVl21
         not       al
EditVl21:mov       ds:[di],al
         call      DispVol
         ret

; ------ seln poloka

EditVl22:test      byte ptr ds:[si+0],b1
         jz        EditVl24

         push      dx
         push      si
         mov       ah,ds:[ColHelp]
         mov       si,offset PocZHlp        ; poet ovovacch zpis
         cmp       dh,4
         je        EditVl23
         mov       si,offset PocPHlp        ; poet doplujcch stop
EditVl23:mov       dx,24*HI
         call      Disp0Txt
         pop       si
         pop       dx

         mov       ch,ds:[ColEdi]
         add       dl,ds:[si+5]
         mov       ah,0
         cmp       dh,4
         je        EditV232
         cmp       byte ptr ds:[TypStop],40
         ja        EditV232
         shr       al,1
EditV232:call      EditNum
         cmp       dh,4
         je        EditV234
         cmp       byte ptr ds:[TypStop],40
         ja        EditV233
         shl       al,1
EditV233:cmp       al,6
         jbe       EditV234
         mov       al,6
EditV234:mov       ds:[di],al
         call      DispVol
         ret

; ------ hexadecimln poloka

EditVl24:test      byte ptr ds:[si+0],b2
         jz        EditVl26

         push      dx
         push      si
         mov       ah,ds:[ColHelp]
         mov       si,offset HexFHlp        ; znak pro formtovn
         mov       dx,24*HI
         call      Disp0Txt
         pop       si
         pop       dx

         mov       ah,ds:[ColEdi]
         add       dl,ds:[si+5]
         call      EditHByt
         jmp       short EditVl21

; ------ volba etiny

EditVl26:test      byte ptr ds:[si+0],b3
         jz        EditVl28
         inc       ax
         cmp       al,3
EditVl27:jbe       EditV271
         mov       al,0
EditV271:mov       ds:[di],al
         call      InitFont                 ; inicializace font
         call      DispADsk                 ; zobrazen vech disk
         ret

; ------ volba zachovn dat

EditVl28:
;test      byte ptr ds:[si+0],b4
         ;jz        EditVl29
         ;inc       ax
         ;cmp       al,2

; ------ volba potu poloek v ROOT

EditVl29:test      byte ptr ds:[si+0],b5
         jz        EditVl2a

         push      dx
         push      si
         mov       ah,ds:[ColHelp]
         mov       dx,24*HI
         mov       si,offset RootHlp
         call      Disp0Txt
         pop       si
         pop       dx

         mov       ch,ds:[ColEdi]
         add       dl,ds:[si+5]
         mov       ah,0
         shl       ax,1
         shl       ax,1
         shl       ax,1
         shl       ax,1                     ; poet poloek ROOT
         call      EditNum
         add       ax,15                    ; zaokrouhlen nahoru
         shr       ax,1
         shr       ax,1
         shr       ax,1
         shr       ax,1
         cmp       al,62
         jbe       EditV211
         mov       al,62
EditV211:jmp       EditVL21

EditVl2a:ret

; ------ Page Down

EditVl41:mov       dh,7
         jmp       short EditVl31

; ------ vlevo

EditVol5:cmp       dl,4
         jne       EditVl53
         mov       dl,53
         jmp       short EditVl31
EditVl53:cmp       dl,28
         mov       dl,4
         je        EditVl31
         mov       dl,28
         jmp       short EditVl31

; ------ Page Up

EditVl30:mov       dh,3
EditVl31:call      SrcPol
EditVl32:mov       ds:[AktVol],al
         call      DispVol
         ret

; ------ vpravo

EditVol6:cmp       dl,53
         jne       EditVl62
         mov       dl,4
         jmp       short EditVl31
EditVl62:cmp       dl,28
         mov       dl,53
         je        EditVl31
         mov       dl,28
         jmp       short EditVl31

; ------ tabeltor

EditVol7:mov       al,ds:[AktVol]
         inc       al
         cmp       al,NUMVOL
         jb        EditVl32
EditVl72:mov       al,0
         jmp       short EditVl32

; ------ zptn tabeltor

EditVol8:mov       al,ds:[AktVol]
         dec       al
         jns       EditVl32
EditVl82:mov       al,NUMVOL-1
         jmp       short EditVl32

EditVol  ENDP

; -----------------------------------------------------------------------------
;        nalezen poloky se souadnicemi DX -> AL (CY=nenalezeno)
; -----------------------------------------------------------------------------

SrcPol   PROC      NEAR

         push      cx
         push      si

         mov       ch,0
         mov       si,offset VolDef
         mov       al,0
SrcPol1: cmp       dx,ds:[si+3]
         je        SrcPol9
         add       si,VOLOFFS
         inc       ax
         cmp       si,offset VolDef0
         jb        SrcPol1
         stc

SrcPol9: pop       si
         pop       cx
         ret

SrcPol   ENDP

; -----------------------------------------------------------------------------
;        nalezen adresy poloky AL -> SI
; -----------------------------------------------------------------------------

GetPol   PROC      NEAR

         push      ax
         mov       ah,VOLOFFS
         mul       ah
         add       ax,offset VolDef
         xchg      ax,si
         pop       ax
         ret

GetPol   ENDP

; -----------------------------------------------------------------------------
;     editace sla AX (CL=ka pole, CH=barva, DX=pozice)
; -----------------------------------------------------------------------------

EditNum  PROC      NEAR

; ------ schova registr

         push      bx
         push      dx
         push      si

; ------ prvn zobrazen sla

         mov       si,ax                    ; pvodn hodnota sla
         xor       bx,bx
         push      dx
         call      MouseOff
         call      DispNum                  ; zobrazen sla
         call      MouseOn
         dec       dl
         call      SetKurz                  ; zobrazen kurzoru
         pop       dx

; ------ ekn na prvn klvesu

EditNum1:push      dx
         call      MouseGet
         pop       dx
         cmp       bl,3
         jne       EditNm11
EditNm10:jmp       EditNum8                 ; lev tlatko
EditNm11:cmp       bl,4
         je        EditNm10                 ; prav tlatko
         call      TestKey
         jc        EditNum1

         call      InpKey                   ; vstup znaku z klvesnice
         cmp       bh,53h
         jne       EditNm14
EditNm13:jmp       EditNum7                 ; Delete
EditNm14:cmp       bl,8
         je        EditNm13                 ; Bs
         cmp       bl,1bh                   ; ESC
         je        EditNm10                 ; peruen editace
         cmp       bl,0dh                   ; ENTER
         je        EditNm10                 ; slo se nemn
         sub       bx,"0"
         jb        EditNum1                 ; neplatn klvesa
         cmp       bl,9
         ja        EditNum1                 ; neplatn klvesa
         xor       ax,ax                    ; vchoz hodnota sla

; ------ pidn nov slice k slu

EditNum2:push      dx
         mov       dx,10
         mul       dx                       ; slo * 10
         pop       dx
         add       ax,bx                    ; pidn zadanho sla

; ------ stanoven maximln hodnoty sla

         mov       bl,10
         cmp       cl,1
         je        EditNum3
         mov       bl,100
         cmp       cl,2
         je        EditNum3
         mov       bx,1000
         cmp       cl,3
         je        EditNum3
         mov       bx,10000

; ------ omezen velikosti sla

EditNum3:cmp       ax,bx
         jb        EditNum4                 ; nen pesah sla
         push      dx
         xor       dx,dx
         div       bx                       ; zarovnn sla
         xchg      ax,dx                    ; AX <- zbytek sla
         pop       dx

; ------ zobrazen nov hodnoty sla

EditNum4:xor       bx,bx
         push      dx
         call      MouseOff
         call      DispNum
         call      MouseOn
         pop       dx

; ------ ekn na dal klvesu

EditNum6:push      dx
         call      MouseGet
         pop       dx
         cmp       bl,3
         jne       EditNm62                 ; nen lev tlatko
         cmp       dh,byte ptr ds:[MousePoz+1]
         jne       EditNum8
         cmp       dl,byte ptr ds:[MousePoz]
         ja        EditNum8
         mov       bl,dl
         add       bl,cl
         cmp       bl,byte ptr ds:[MousePoz]
         ja        EditNum9
         jmp       short EditNum8

EditNm62:cmp       bl,4
         je        EditNum8                 ; prav tlatko
         call      TestKey
         jc        EditNum6

EditNm64:call      TestKey
         jc        EditNum6

         call      InpKey
         cmp       bh,53h
         je        EditNum7                 ; Delete
         cmp       bl,8
         je        EditNum7                 ; Bs
         cmp       bl,1bh
         je        EditNum8                 ; peruen editace
         cmp       bl,0dh
         je        EditNum9                 ; ukonen volby ENTER
         sub       bx,"0"
         jb        EditNum6
         cmp       bl,9
         ja        EditNum6
         jmp       EditNum2

; ------ zruen posledn slice BS, DELETE

EditNum7:mov       bx,10
         push      dx
         xor       dx,dx
         div       bx
         pop       dx
         jmp       short EditNum4           ; dal klvesa

; ------ peruen ESC, navrcen pvodnho sla

EditNum8:mov       ax,si                    ; pvodn slo
EditNum9:xor       bx,bx
         call      MouseOff
         call      DispNum                  ; zobrazen vsledn hodnoty sla
         call      MouseOn
         call      KurzOff                  ; vypnut kurzoru

; ------ nvrat registr

         pop       si
         pop       dx
         pop       bx
         ret

EditNum  ENDP

; -----------------------------------------------------------------------------
;        editace hexadecimlnho bajtu AL (AH=barva, DX=pozice)
; -----------------------------------------------------------------------------

EditHByt PROC      NEAR

; ------ schova registr

         push      bx
         push      cx
         push      dx

; ------ prvn zobrazen sla

         mov       ch,al                    ; pvodn hodnota sla
         push      dx
         call      MouseOff
         call      DispHByt
         call      MouseOn
         dec       dl
         call      SetKurz                  ; zobrazen kurzoru
         pop       dx

; ------ ekn na prvn klvesu

EditHBy1:push      dx
         call      MouseGet
         pop       dx
         cmp       bl,3
         jne       EditHB11
EditHB10:jmp       EditHBy8                 ; lev tlatko
EditHB11:cmp       bl,4
         je        EditHB10                 ; prav tlatko
         call      TestKey
         jc        EditHBy1

         call      InpKey                   ; vstup znaku z klvesnice
         cmp       bh,53h
         jne       EditHB14
EditHB13:jmp       EditHBy7                 ; Delete
EditHB14:cmp       bl,8
         je        EditHB13                 ; Bs
         cmp       bl,1bh                   ; ESC
         je        EditHB10                 ; peruen editace
         cmp       bl,0dh                   ; ENTER
         je        EditHB10                 ; slo se nemn
         sub       bl,"0"
         jb        EditHBy1                 ; neplatn klvesa
         cmp       bl,9
         jbe       EditHB17
         sub       bl,7
         cmp       bl,15
         ja        EditHBy1
         cmp       bl,10
         jb        EditHBy1
EditHB17:mov       al,0                     ; vchoz hodnota sla

; ------ pidn nov slice k slu

EditHBy2:shl       al,1
         shl       al,1
         shl       al,1
         shl       al,1
         or        al,bl                    ; pidn zadanho sla

; ------ zobrazen nov hodnoty sla

EditHBy4:push      dx
         call      MouseOff
         call      DispHByt
         call      MouseOn
         pop       dx

; ------ ekn na dal klvesu

EditHBy6:push      dx
         call      MouseGet
         pop       dx
         cmp       bl,3
         jne       EditHB62                 ; nen lev tlatko
         cmp       dh,byte ptr ds:[MousePoz+1]
         jne       EditHBy8
         cmp       dl,byte ptr ds:[MousePoz]
         ja        EditHBy8
         mov       bl,dl
         add       bl,2
         cmp       bl,byte ptr ds:[MousePoz]
         ja        EditHBy9
         jmp       short EditHBy8

EditHB62:cmp       bl,4
         je        EditHBy8                 ; prav tlatko
         call      TestKey
         jc        EditHBy6

EditHB64:call      TestKey
         jc        EditHBy6

         call      InpKey
         cmp       bh,53h
         je        EditHBy7                 ; Delete
         cmp       bl,8
         je        EditHBy7                 ; Bs
         cmp       bl,1bh                   ; ESC
         je        EditHBy8                 ; peruen editace
         cmp       bl,0dh                   ; ENTER
         je        EditHBy9                 ; konec editace
         sub       bl,"0"
         jb        EditHBy6                 ; neplatn klvesa
         cmp       bl,9
         jbe       EditHBy2
         sub       bl,7
         cmp       bl,15
         ja        EditHBy6
         cmp       bl,10
         jb        EditHBy6
         jmp       short EditHBy2

; ------ Delete

EditHBy7:shr       al,1
         shr       al,1
         shr       al,1
         shr       al,1
         jmp       short EditHBy4

; ------ peruen ESC, navrcen pvodnho sla

EditHBy8:mov       al,ch                    ; pvodn slo
EditHBy9:call      MouseOff
         call      DispHByt                 ; zobrazen vsledn hodnoty sla
         call      MouseOn
         call      KurzOff                  ; vypnut kurzoru

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         ret

EditHByt ENDP

; 
;
;                           Obsluha zobrazen
;
; 
;
; -----------------------------------------------------------------------------
;        zobrazen znaku AX na pozici formtovn
; -----------------------------------------------------------------------------

DispFCh  PROC      NEAR

         push      cx
         push      dx

         mov       dx,ds:[PozMap]           ; potek okna
         inc       dh
         add       dl,11
         mov       cl,ds:[AktStop]          ; stopa
         mov       ch,ds:[NumStop]
         cmp       ch,60
         jb        DispFCh1
         shr       ch,1
DispFCh1:cmp       cl,ch
         jb        DispFCh2
         sub       cl,ch
         add       dh,6
         cmp       byte ptr ds:[NumStran],2
         je        DispFCh2
         dec       dh
DispFCh2:add       dl,cl
         add       dh,ds:[AktStran]
         call      Disp1Chr

         pop       dx
         pop       cx
         ret

DispFCh  ENDP

; -----------------------------------------------------------------------------
;        zobrazen informanho okna o prbhu formtovn
; -----------------------------------------------------------------------------
;
DispInf  PROC      NEAR

         call      MouseOff
         push      ax
         push      bx
         push      cx
         push      dx
         push      si

         mov       al,ds:[SelChar]
         mov       ds:[TextOK+2],al

; ------ zobrazen stnu pod oknem

         mov       dx,11*HI+59
         mov       cx,11*HI+18
         call      StinWin

; ------ zobrazen horn linky okna

         mov       dx,11*HI+59
         mov       ah,ds:[ColRFR]
         mov       al,""
         call      Disp1Chr
         mov       cl,16
         mov       al,""
         call      DispChr
         mov       al,""
         call      Disp1Chr

; ------ vnitn dky okna

         mov       ch,9                     ; poet dk
DispInf2:mov       dl,59
         inc       dh
         mov       al,""
         call      Disp1Chr
         mov       al," "
         call      DispChr
         mov       al,""
         call      Disp1Chr
         dec       ch
         jnz       DispInf2

; ------ spodn dek okna

         inc       dh
         mov       dl,59
         mov       al,""
         call      Disp1Chr
         mov       al,""
         call      DispChr
         mov       al,""
         call      Disp1Chr

; ------ zobrazen text nadpis

         mov       dx,12*HI+60
         mov       si,offset TextKap
         mov       ah,ds:[ColRF]
         call      Disp0Txt

         mov       dx,13*HI+61
         mov       si,offset TextVol
         call      Disp0Txt

         mov       dx,14*HI+61
         mov       si,offset TextBad
         call      Disp0Txt

; ------ text "doba"

         mov       dx,19*HI+63
         mov       si,offset TextDob
         call      Disp0Txt

; ------ oddlovac linky

         mov       dx,15*HI+60
         mov       cl,16
         mov       ah,ds:[ColRFR]
         mov       al,""
         call      DispChr
         mov       dx,18*HI+60
         call      DispChr
         mov       byte ptr ds:[CitSek],1 ; pznak k okamitmu zobrazen asu

; ------ nvrat registr

         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         call      MouseOn
                                            ; pokrauje zobrazen kapacit !!!

DispInf  ENDP

; -----------------------------------------------------------------------------
;        zobrazen kapacit disku v informanm okn
; -----------------------------------------------------------------------------

DispKap  PROC      NEAR

         call      MouseOff
         push      ax
         push      bx
         push      cx
         push      dx
         push      si

; ------ zobrazen celkov kapacity

         mov       dx,12*HI+67
         mov       ch,ds:[ColRF0]
         mov       ax,word ptr ds:[CelkKap]
         mov       bx,word ptr ds:[CelkKap+2]
         mov       cl,1
         call      DispNum

; ------ zobrazen voln kapacity

         mov       dx,13*HI+67
         mov       ax,word ptr ds:[CitVol]
         mov       bx,word ptr ds:[CitVol+2]
         mov       cl,1
         call      DispNum

; ------ zobrazen vadn kapacity

         mov       dx,14*HI+67
         mov       ax,word ptr ds:[CitBad]
         mov       bx,word ptr ds:[CitBad+2]
         mov       cl,1
         call      DispNum

; ------ zobrazen pznak

         mov       al,ds:[ErrBoot]
         mov       si,offset TextBoot
         mov       dx,16*HI+61
         call      DispInS

         mov       al,ds:[ErrRoot]
         mov       si,offset TextRoot
         mov       dx,17*HI+61
         call      DispInS

         mov       al,ds:[ErrFat1]
         mov       si,offset TextFat1
         mov       dx,16*HI+69
         call      DispInS

         mov       al,ds:[ErrFat2]
         mov       si,offset TextFat2
         mov       dx,17*HI+69
         call      DispInS

; ------ nvrat registr

         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         call      MouseOn
         ret

DispKap  ENDP

; -----------------------------------------------------------------------------
;        zobrazen jednoho pznaku (pozice DX, text SI, stav AL)
; -----------------------------------------------------------------------------

DispInS  PROC      NEAR

         mov       ah,ds:[ColRF]
         call      Disp0Txt
         mov       si,offset TextOK
         cmp       al,0                     ; je OK ?
         je        DispInS1
         mov       si,offset TextNOK
         cmp       al,0ffh                  ; vadn ?
         je        DispInS1                 ; vadn
         mov       si,offset TextXOK
DispInS1:mov       ah,ds:[ColRF0]
         call      Disp0Txt
         ret

DispInS  ENDP

; -----------------------------------------------------------------------------
;        zobrazen mapy disku
; -----------------------------------------------------------------------------

DispMap  PROC      NEAR

; ------ schova registr

         call      MouseOff
         push      ax
         push      bx
         push      cx
         push      dx
         push      si

; ------ pedlov stopa mapy

         mov       al,ds:[NumStop]
         cmp       al,60
         jb        DispMp10
         shr       al,1
DispMp10:mov       ds:[CitMap],al           ; ta stop mapy

; ------ zobrazen stnu pod oknem

         mov       dx,ds:[PozMap]           ; poten pozice
         mov       cx,ds:[SirMap]           ; rozmry okna
         call      StinWin

; ------ zobrazen rmu

         push      dx
         mov       ah,ds:[ColRF]
DispMp11:push      dx
         mov       al," "
         call      DispChr
         pop       dx
         inc       dh
         dec       ch
         jnz       DispMp11
         pop       dx

; ------ zobrazen mapy

         mov       bl,0                     ; poten slo stopy
DispMap1:mov       bh,0                     ; slo strany

; ------ zobrazen hornho okraje

         mov       ah,ds:[ColRF0]           ; barva rmeku
         push      dx
         add       dl,10
         mov       al,""
         call      Disp1Chr
         mov       al,""
         mov       cl,ds:[CitMap]
         call      DispChr
         mov       al,""
         call      Disp1Chr
         pop       dx
         inc       dh

; ------ lev okraj dku

DispMap2:push      dx
         inc       dl
         mov       ah,ds:[ColRF]
         mov       si,offset TextStra
         call      Disp0Txt
         mov       al,bh
         add       al,"0"
         mov       ah,ds:[ColRF0]
         call      Disp1Chr
         inc       dx
;         mov       ah,ds:[ColRF]
         mov       al,""
         call      Disp1Chr

; ------ zobrazen vnitku dku

         mov       cl,ds:[CitMap]
         mov       ah,ds:[ColRFNul]
         mov       al,""
         call      DispChr

; ------ prav okraj

         mov       ah,ds:[ColRF0]           ; barva rmeku
         mov       al,""
         call      Disp1Chr                 ; zobrazen pravho okraje
         pop       dx
         inc       dh
         inc       bh                       ; zven sla strany
         cmp       bh,ds:[NumStran]         ; jsou ji vechny strany ?
         jb        DispMap2                 ; dal strana

; ------ zobrazen spodnho okraje

         push      bx
         push      dx
         add       dl,10
         mov       al,""
         call      Disp1Chr                 ; zobrazen levho spodnho rohu

         mov       bh,ds:[CitMap]           ; poet stop k zobrazen
DispMap4:push      ax
         mov       al,bl                    ; slo stopy
         mov       ah,0
         mov       cl,5
         div       cl                       ; dlitelnost 5
         or        ah,ah                    ; je slo dliteln 5 ?
         pop       ax
         mov       al,""                   ; dliteln 5
         jz        DispMp42
         mov       al,""
DispMp42:call      Disp1Chr

         inc       bl
         dec       bh
         jnz       DispMap4

         mov       al,""
         call      Disp1Chr                 ; zobrazen pravho dolnho rohu
         pop       dx
         pop       bx
         inc       dh

; ------ zobrazen sel stop

         push      dx
         add       dl,10
         mov       bh,ds:[CitMap]           ; poet stop k zobrazen
;         mov       ah,ds:[ColRF0]
DispMap5:
         push      ax
         mov       al,bl                    ; slo stopy
         mov       ah,0
         mov       cl,5
         div       cl
         or        ah,ah                    ; je dliteln 5 ?
         pop       ax
         jnz       DispMp52                 ; nen dliteln 5

         push      ax
         push      bx
         push      cx
         push      dx

         mov       al,bl
         mov       ch,ah
         xor       bx,bx
         xor       ah,ah
         mov       cl,2
         call      DispNum                  ; zobrazen sla stopy

         pop       dx
         pop       cx
         pop       bx
         pop       ax

DispMp52:inc       dl                       ; zven pozice
         inc       bx                       ; zven sla stopy
         dec       bh
         jnz       DispMap5                 ; dal stopa
         pop       dx

; ------ pprava k zobrazen dalho rmeku

         add       dh,2
         cmp       bl,ds:[NumStop]          ; jsou ji vechny stopy ?
         jae       DispMap6
         mov       al,ds:[NumStop]
         sub       al,ds:[CitMap]
         mov       ds:[CitMap],al
         jmp       DispMap1                 ; dal stopy

; ------ oddlovac ra mezi mapami pro 80 stop

DispMap6:cmp       byte ptr ds:[NumStop],60
         jbe       DispMap9
         sub       dh,7
         cmp       byte ptr ds:[NumStran],1
         jne       DispMap7
         inc       dh
DispMap7:mov       al,""
;         mov       ah,ds:[ColRF0]
         mov       cl,byte ptr ds:[SirMap]
         call      DispChr

; ------ nvrat registr

DispMap9:pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         call      MouseOn
         ret

DispMap  ENDP

; -----------------------------------------------------------------------------
;        zobrazen vech disk
; -----------------------------------------------------------------------------

DispADsk PROC      NEAR

         push      ax
         mov       al,0
DispADs2:call      DispDisk                 ; zobrazeni disku A:
         inc       ax
         cmp       al,ds:[NumDisk]
         jb        DispADs2
         pop       ax
         ret

DispADsk ENDP

; -----------------------------------------------------------------------------
;        zobrazen disku AL
; -----------------------------------------------------------------------------

DispDisk PROC      NEAR

; ------ schova registr

         call      MouseOff                 ; vypnut kurzoru myi
         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di

; ------ pprava registr

         mov       bh,0
         mov       bl,al                    ; slo disku
         mov       dh,11                    ; poten dek k zobrazen
         mov       dl,ds:[PozDiskT+bx]      ; pozice k zobrazen disku

; ------ zobrazen stnu

         mov       cl,17
         mov       ch,11
         call      StinWin                  ; zobrazen stnu pod oknem

; ------ horn okraj okna

         mov       ah,ds:[ColDiskR]         ; barva rmu
         mov       al,""
         call      Disp1Chr
         mov       al,""
         mov       cl,15
         call      DispChr
         mov       al,""
         call      Disp1Chr
         sub       dl,17
         inc       dh

; ------ stedn dek nadpisu - slo disku

         mov       al,""
         call      Disp1Chr
         mov       al," "
         mov       cl,4
         call      DispChr
         mov       si,offset TextDisk
         mov       ah,ds:[ColDisk1]
         call      Disp0Txt
         mov       al,bl
         add       al,"A"
         call      Disp1Chr
         mov       al,":"
         call      Disp1Chr
         mov       ah,ds:[ColDiskR]         ; barva rmu
         mov       cl,4
         mov       al," "
         call      DispChr
         mov       al,""
         call      Disp1Chr
         sub       dl,17
         inc       dh

; ------ oddlovac linka

         mov       al,""
         call      Disp1Chr
         mov       al,""
         mov       cl,15
         call      DispChr
         mov       al,""
         call      Disp1Chr
         sub       dl,17
         inc       dh

; ------ dek volby "Automatick"

;         mov       al,""
;         call      Disp1Chr
;         mov       al," "
;         call      Disp1Chr
;         mov       bh,ds:[ColDisk1]         ; bn barva poloek
;         mov       ah,bh
;         cmp       bl,ds:[AktDisk]          ; je to aktivn disk ?
;         jne       DispDsk2                 ; nen to aktivn disk
;         cmp       byte ptr ds:[AktVolby],0 ; jsou aktivn volby ?
;         jne       DispDsk2                 ; jsou aktivn volby
;         mov       ah,ds:[ColDisk4]         ; vysvcen barva
;         cmp       byte ptr ds:[AktForm],0  ; je to atkivn formt ?
;         jne       DispDsk2                 ; nen to aktivn format
;         mov       ah,ds:[ColDisk3]         ; barva kurzoru
;         mov       bh,ah
;DispDsk2:call      Disp1Chr                 ; zobrazen jedn mezery
;         mov       al,"A"
;         call      Disp1Chr                 ; zobrazen hork klvesy
;         mov       si,offset TextAut        ; text "Automatick"
;         mov       ah,bh
;         call      Disp0Txt                 ; zobrazen textu
;         mov       al," "
;         call      Disp1Chr                 ; zobrazen mezery
;         mov       ah,ds:[ColDiskR]         ; barva rmu
;         call      Disp1Chr
;         mov       al,""
;         call      Disp1Chr
;         sub       dl,17
;         inc       dh

; ------ pprava k zobrazen text formt

         mov       bh,0
         mov       al,ds:[TypDiskT+bx]      ; typ disku
         mov       ah,0
         shl       ax,1                     ; typ disku * 2
         xchg      ax,si                    ; SI <- typ disku * 2
         mov       si,ds:[si+TabForm-2]     ; adresa popisovae formtu
         mov       cl,ds:[si]               ; poet poloek formt
         inc       si
         mov       ch,0                     ; slo formtu k zobrazen

; ------ lev okraj

DispDsk3:mov       ah,ds:[ColDiskR]         ; barva rmu
         mov       al,""
         call      Disp1Chr
         mov       al," "
         call      Disp1Chr

; ------ uren barvy dku

         mov       bh,ds:[ColDisk1]         ; bn barva poloek
         mov       ah,bh
         cmp       bl,ds:[AktDisk]          ; je to aktivn disk ?
         jne       DispDsk4                 ; nen to aktivn disk
         cmp       byte ptr ds:[AktVolby],0 ; jsou aktivn volby ?
         jne       DispDsk4                 ; jsou aktivn volby
         mov       ah,ds:[ColDisk4]         ; vysvcen barva
         cmp       ds:[AktForm],ch          ; je to aktivn formt ?
         jne       DispDsk4                 ; nen to aktivn format
         mov       ah,ds:[ColDisk3]         ; barva kurzoru
         mov       bh,ah
DispDsk4:call      Disp1Chr                 ; zobrazen mezery
         call      Disp1Chr

; ------ zobrazen przdnho dku

         dec       cl
         jns       DispDsk5
         push      cx
         mov       cl,11
         call      DispChr
         pop       cx
         jmp       short DispDsk6

; ------ zobrazen textu volby formtu

DispDsk5:mov       al,ch                    ; slo formtu
         add       al,"1"
         call      Disp1Chr                 ; zobrazen sla formtu
         mov       ah,bh
         mov       al,":"
         call      Disp1Chr
         mov       al," "
         call      Disp1Chr
         test      byte ptr ds:[si+0],b3    ; je to nestandardn formt ?
         jz        DispDs52                 ; je to standardn formt
         mov       al,"*"                   ; pznak nestandardnho formtu
DispDs52:call      Disp1Chr
         add       si,4
         push      cx
         mov       cl,5
         call      DispTxt
         mov       al," "
         mov       cl,2
         call      DispChr
         pop       cx

; ------ prav okraj

DispDsk6:mov       ah,ds:[ColDiskR]         ; barva rmu
         call      Disp1Chr
         mov       al,""
         call      Disp1Chr

; ------ pprava pro dal poloku

         sub       dl,17
         inc       dh
         inc       ch
         cmp       ch,7
         jae       DispDsk7
         jmp       DispDsk3

; ------ spodn okraj okna

DispDsk7:mov       ah,ds:[ColDiskR]         ; barva rmu
         mov       al,""
         call      Disp1Chr
         mov       al,""
         mov       cl,15
         call      DispChr
         mov       al,""
         call      Disp1Chr

; ------ zobrazen npovdy pro aktivn formt aktivnho disku

         cmp       byte ptr ds:[AktVolby],0 ; jsou aktivn volby ?
         jne       DispDs99                 ; jsou aktivn volby
         cmp       bl,ds:[AktDisk]          ; je to aktivn disk ?
         je        DispDs80                 ; je to aktivn disk
DispDs99:jmp       DispDsk9
DispDs80:mov       dx,24*HI

; ------ zobrazen npovdy pro automatick formt

;         cmp       byte ptr ds:[AktForm],0  ; automatick formt ?
;         jne       DispDsk8                 ; nen automatick formt
;         mov       ah,ds:[ColHelp]
;         mov       si,offset FormHlpA
;         call      Disp0Txt
;         jmp       short DispDs88

; ------ pprava prvn sti textu

DispDsk8:mov       si,offset FormHlp1
         mov       ax,"45"                  ; disk 5 1/4"
         cmp       byte ptr ds:[TypDisk],3  ; je disk 3 1/2" ?
         jb        DispDs82                 ; je disk 5 1/4"
         mov       ax,"23"                  ; jinak disk 3 1/2"
DispDs82:mov       ds:[si+2],al
         mov       ds:[si+6],ah             ; oznaen disku 3 1/2 nebo 5 1/4

         mov       al,"D"                   ; disketa DD
         cmp       byte ptr ds:[NumSekt],13
         jbe       DispDs83                 ; disketa DD
         mov       al,"H"                   ; disketa HD
         cmp       byte ptr ds:[NumSekt],30
         jb        DispDs83
         mov       al,"Q"                   ; jinak QD
DispDs83:mov       ds:[si+9],al             ; oznaen DD, HD, QD

         mov       al,"S"                   ; 1 strana
         cmp       byte ptr ds:[NumStran],1 ; je 1 strana ?
         je        DispDs84                 ; je 1 strana
         mov       al,"D"                   ; 2 strany
DispDs84:mov       ds:[si+12],al            ; oznaen SS nebo DS

; ------ zobrazen prvn sti tetxu

         mov       ah,ds:[ColHelp]
         call      Disp0Txt

; ------ zobrazen kapacity disku

         mov       ch,ah                    ; barva
         mov       ax,word ptr ds:[CelkKap] ; celkov kapacita disku
         mov       bx,word ptr ds:[CelkKap+2]
         mov       cl,0                     ; CL = ka pole
         call      DispNum                  ; zobrazen celkov kapacity disku
         mov       ah,ch

; ------ zobrazen druh sti textu

         mov       si,offset FormHlp2
         call      Disp0Txt

; ------ zobrazen potu poloek v ROOT

         mov       ch,ah                    ; barva
         mov       ax,ds:[RootMax]          ; poet poloek v ROOT
         xor       bx,bx
         mov       cl,0                     ; CL ka pole
         call      DispNum                  ; zobrazen potu poloek v ROOT
         mov       ah,ch

; ------ zobrazen zbytku mezer

DispDs88:mov       cl,38
         sub       cl,dl
         jbe       DispDs89
         mov       al," "
         call      DispChr

; ------ zobrazen zbytku textu npovdy

DispDs89:mov       ch,ds:[ColHelp1]         ; vysvcen barva textu
         mov       si,offset FormHlp0       ; text
         call      Disp0Txt                 ; zobrazen textu npovdy

; ------ nvrat registr

DispDsk9:pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         call      MouseOn                  ; zapnut kurzoru myi
         ret

DispDisk ENDP

; -----------------------------------------------------------------------------
;        zobrazen voleb
; -----------------------------------------------------------------------------

DispVol  PROC      NEAR

; ------ schova registr

         call      MouseOff                 ; vypnut kurzoru myi
         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp

; ------ pprava k zobrazen poloek

         mov       si,offset VolDef         ; definice poloek
         mov       bp,offset VolText        ; texty npovd k volbm
         mov       bl,0                     ; ukazatel sla volby

; ------ pprava barvy poloky

DispVol1:mov       ah,ds:[ColVol0]          ; bn barva poloky
         mov       bh,ds:[ColVol]
         cmp       bl,ds:[AktVol]           ; je to aktivn poloka ?
         jne       DispVol2                 ; nen to aktivn poloka
         cmp       byte ptr ds:[AktVolby],0 ; jsou aktivn volby ?
         je        DispVol2                 ; volby nejsou aktivn
         mov       ah,ds:[ColVolK]          ; jinak barva kurzoru
         mov       bh,ah

; ------ zobrazen vodn mezery poloky

DispVol2:mov       dx,ds:[si+3]             ; poten pozice na obrazovce
         dec       dl
         mov       al," "
         call      Disp1Chr                 ; zobrazen vodn mezery poloky

; ------ zobrazen nzvu poloky

         push      si
         mov       si,bp
         mov       cl,ds:[si]
         mov       ch,0
         call      Disp0Txt
         pop       si
         inc       bp
         add       bp,cx

; ------ zobrazen oddlovac mezery

         sub       cl,ds:[si+5]             ; offset potku parametru
         neg       cl
         call      DispChr                  ; zobrazen oddlovac mezery

; ------ zobrazen jednoduchho pepnae

         mov       ah,bh
         mov       di,ds:[si+1]             ; adresa parametru poloky
         mov       al,ds:[di]               ; parametr poloky
         mov       cl,ds:[si+6]             ; dlka pole parametru poloky
         test      byte ptr ds:[si+0],b0    ; je to jednoduch pepna ?
         jz        DispVol4                 ; nen to jednoduch pepna
         cmp       al,0                     ; je pepna zapnut ?
         mov       al,ds:[SelChar]          ; volba - pepna zapnut
         jne       DispVol3                 ; pepna je zapnut
         mov       al,"-"                   ; jinak pepna neaktivn
DispVol3:call      Disp1Chr                 ; zobrazen pepnae
         jmp       short DispVol8

; ------ zobrazen dekadick seln poloky

DispVol4:test      byte ptr ds:[si+0],b1    ; je dekadick seln poloka ?
         jz        DispVol5                 ; nen dekadick seln poloka
         push      bx
         push      ax
         xor       bx,bx
         mov       ch,ah                    ; barva sla
         cmp       word ptr ds:[si+1],offset ParStop ; je volba dalch stop ?
         jne       DispVl42                 ; nen volba dalch stop
         mov       ah,"6"                   ; max. 6 stop

         cmp       byte ptr ds:[TypStop],40
         ja        DispVl41                 ; je 80 stop
         shr       al,1                     ; poet stop/2
         mov       ah,"3"                   ; max. 3 stopy

DispVl41:mov       ds:[PocPHlp1],ah         ; max. poet stop
         mov       ds:[PocPHlp2],ah
DispVl42:mov       ah,0
         call      DispNum                  ; zobrazen seln poloky
         pop       ax
         pop       bx
         jmp       short DispVol8

; ------ zobrazen hexadecimln poloky - bajt

DispVol5:test      byte ptr ds:[si+0],b2    ; je hexadecimln poloka ?
         jz        DispVol6
         call      DispHByt                 ; zobrazen hexadecimlnho bajtu
         jmp       short DispVol8

; ------ zobrazen kdu etiny

DispVol6:test      byte ptr ds:[si+0],b3    ; je volba etiny ?
         jz        DispVol7                 ; nen volba etiny
         push      si
         mov       si,offset VolTCest
DispVl62:push      ax
         mul       cl
         add       si,ax
         pop       ax
         call      DispTxt
         pop       si
         jmp       short DispVol8

; ------ zobrazen kdu zachovn dat

DispVol7:;test      byte ptr ds:[si+0],b4    ; je volba zachovn dat ?
         ;jz        DispVl72
         ;push      si
         ;mov       si,offset VolTZach
         ;jmp       short DispVl62

; ------ zobrazen potu poloek na Root

DispVl72:test      byte ptr ds:[si+0],b5    ; je volba potu poloek na Root ?
         jz        DispVol8
         or        al,al
         jz        DispVl73
         push      bx
         push      ax
         mov       ch,ah                    ; barva sla
         xor       bx,bx
         mov       ah,0
         shl       ax,1
         shl       ax,1
         shl       ax,1
         shl       ax,1
         call      DispNum                  ; zobrazen seln poloky
         pop       ax
         pop       bx
         jmp       short DispVol8

DispVl73:push      si
         mov       si,offset VolTStd
         jmp       short DispVl62

; ------ zobrazen zvren mezery

DispVol8:mov       al," "
         call      Disp1Chr

; ------ adresa dal poloky

         add       si,VOLOFFS
         inc       bx                       ; zven ukazatele sla poloky
         cmp       bl,NUMVOL                ; jsou ji vechny poloky ?
         je        DispVol9                 ; jsou ji vechny poloky
         jmp       DispVol1                 ; zobrazen dal poloky

; ------ adresa npovdy k zobrazen

DispVol9:cmp       byte ptr ds:[AktVolby],0 ; jsou volby aktivn ?
         je        DispVolC                 ; volby nejsou aktivn
         mov       cl,ds:[AktVol]           ; Aktivn poloka voleb
         mov       ch,0
         mov       si,offset VolHlp
         jcxz      DispVolB
         cld
         mov       ah,0
DispVolA:lodsb
         add       si,ax
         loop      DispVolA

; ------ zobrazen prvn sti npovdy

DispVolB:mov       dx,24*HI
         mov       ah,ds:[ColHelp]
         mov       al," "
         call      Disp1Chr                 ; zobrazen vodn mezery
         call      Disp0Txt                 ; zobrazen textu npovdy

; ------ zobrazen mezer do zbytku dku

         mov       cl,41
         sub       cl,dl
         mov       al," "
         call      DispChr

; ------ zobrazen druh sti npovdy

         mov       si,offset VolHlp0
         mov       ch,ds:[ColHelp1]
         call      Disp0Txt

; ------ nvrat registr

DispVolC:pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         call      MouseOn                  ; zapnut kurzoru myi
         ret

DispVol  ENDP

; -----------------------------------------------------------------------------
;        zobrazen podkladovho rmu
; -----------------------------------------------------------------------------

DispRam  PROC      NEAR

; ------ schova registr

         call      MouseOff                 ; vypnut kurzoru myi
         push      ax
         push      bx
         push      cx
         push      dx
         push      si

; ------ zobrazen horn linky nadpisu

         mov       dh,0                     ; poten dek
         mov       ah,ds:[ColRamN]          ; barva rmu nadpisu
         mov       al,""                   ; lev horn roh
         mov       bx,""                  ; oddlovac znak a linka
         mov       ch,""                   ; prav horn roh
         call      DispRL1                  ; zobrazen horn linky nadpisu

; ------ zobrazen stedn linky nadpisu

         mov       al,""                   ; lev okraj
         mov       bx," "                  ; oddlovac znak a linka
         mov       ch,""                   ; prav okraj
         call      DispRL1                  ; zobrazen stedn linky nadpisu

; ------ zobrazen spodn linky nadpisu

         mov       al,""                   ; lev okraj
         mov       bx,""                  ; oddlovac znak a linka
         mov       ch,""                   ; prav okraj
         call      DispRL1                  ; zobrazen spodn linky nadpisu

; ------ zobrazen dk voleb

         mov       bx," "                  ; lev a stedn znak
         mov       cx,""*HI + 5            ; prav znak, 5 dk
         call      DispRL2

; ------ oddlovac linka pod volbami

         mov       bx,""                  ; lev a stedn znak
         mov       cx,""*HI + 1            ; prav znak, 1 dek
         call      DispRL2                  ; oddlovac linka

; ------ zobrazen podkladu

         mov       ah,ds:[ColPod]           ; barva podkladu
         mov       bx,""                  ; lev a stedn znak
         mov       cx,""*HI + 15           ; prav znak, 15 dk
         call      DispRL2

; ------ dek npovdy

         mov       ah,ds:[ColHelp]          ; bavra rmu npovdy
         mov       bx,"  "                  ; lev a stedn znak
         mov       cx," "*HI + 1            ; prav znak, 1 dek
         call      DispRL2

; ------ zobrazen licennho textu

         mov       si,offset LicTxt         ; licenn text
         mov       dx,1*HI+20               ; poten pozice
         mov       ah,ds:[ColNadp]          ; barva textu
         call      Disp0Txt                 ; zobrazen textu

; ------ zobrazen stnu pod volbami

         mov       dx,9*HI+2
         mov       cl,78
         call      DispStin

; ------ nvrat registr

         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         call      MouseOn                  ; zapnut kurzoru myi

; ------ zobrazen data a asu

         call      DispDate                 ; zobrazen aktulnho data
         mov       byte ptr ds:[CitSek],1
         ret

DispRam  ENDP

; -----------------------------------------------------------------------------
;        zobrazen podkladov plochy
; -----------------------------------------------------------------------------

DispPod  PROC      NEAR

; ------ schova registr

         call      MouseOff                 ; vypnut kurzoru myi
         push      ax
         push      bx
         push      cx
         push      dx

; ------ zobrazen podkladu

         mov       dh,10
         mov       ah,ds:[ColPod]           ; barva podkladu
         mov       bx,""                  ; lev a stedn znak
         mov       cx,""*HI + 14           ; prav znak, 14 dk
         call      DispRL2

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         call      MouseOn                  ; zapnut kurzoru myi
         ret

DispPod  ENDP

; -----------------------------------------------------------------------------
;        zobrazen horn linky rmu
; (dek DH, AX=prvn znak, BH=linka, BL=oddlovac znak, CH=posledn znak)
; -----------------------------------------------------------------------------

DispRL1  PROC      NEAR

         mov       dl,0
         call      Disp1Chr                 ; zobrazen levho okraje
         mov       al,bh                    ; vodorovn linka
         mov       cl,12                    ; dlka linky
         call      DispChr                  ; zobrazen vodorvn linky
         mov       al,bl                    ; oddlovac znak
         call      Disp1Chr                 ; zobrazen oddlovacho znaku
         mov       al,bh                    ; vodorovn linka
         mov       cl,52                    ; dlka linky
         call      DispChr                  ; zobrazen vodorovn linky
         mov       al,bl                    ; oddlovac znak
         call      Disp1Chr                 ; zobrazen oddlovacho znaku
         mov       al,bh                    ; vodorovn linka
         mov       cl,12                    ; dlka linky
         call      DispChr                  ; zobrazen vodorovn linky
         mov       al,ch                    ; posledn znak
         call      Disp1Chr                 ; zobrazen poslednho znaku
         inc       dh                       ; zven ukazatele dku
         ret

DispRL1  ENDP

; -----------------------------------------------------------------------------
;       zobrazen linky (dek DH, BH=lev, BL=stedn, CH=prav znak, CL=dk)
; -----------------------------------------------------------------------------

DispRL2  PROC      NEAR

DispRL22:push      cx
         mov       dl,0                     ; poten pozice
         mov       al,bh                    ; lev okraj
         call      Disp1Chr                 ; zobrazen levho okraje
         mov       al,bl                    ; stedn znak
         mov       cl,78                    ; dlka dku
         call      DispChr                  ; zobrazen stednho znaku
         mov       al,ch                    ; prav znak
         call      Disp1Chr                 ; zobrazen pravho znaku
         inc       dh                       ; zven ukazatele dku
         pop       cx
         dec       cl
         jnz       DispRL22
         ret

DispRL2  ENDP

; -----------------------------------------------------------------------------
;        zobrazen aktulnho data
; -----------------------------------------------------------------------------

DispDate PROC      NEAR

; ------ schova registr

         call      MouseOff                 ; vypnut kurzoru myi
         push      ax
         push      bx
         push      cx
         push      dx

; ------ zjitn systmovho data

         mov       ah,2ah
         int       21h                      ; zjitn systmovho data

; ------ pprava pro zobrazen

         mov       bx,dx                    ; schova dne a msce
         mov       dx,102h                  ; poten pozice k zobrazen
         mov       ah,ds:[ColDat]           ; barva k zobrazen data

; ------ zobrazen data

         mov       al,bl                    ; aktuln den
         call      Disp2NmS                 ; zobrazen dne
         mov       al,"."
         call      Disp1Chr                 ; zobrazen oddlovac teky
         mov       al,bh                    ; msc
         call      Disp2Nm0                 ; zobrazen msce
         mov       al,"."
         call      Disp1Chr                 ; zobrazen oddlovac teky
         push      ax
         push      dx
         mov       ax,100
         xchg      ax,cx
         xor       dx,dx
         div       cx                       ; vpoet stolet a roku
         mov       ah,dl                    ; rok
         xchg      ax,cx
         pop       dx
         pop       ax
         mov       al,cl                    ; stolet
         call      Disp2Nm0                 ; zobrazen stolet
         mov       al,ch                    ; rok
         call      Disp2Nm0                 ; zobrazen roku

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         call      MouseOn                  ; zapnut kurzoru myi
         ret

DispDate ENDP

; -----------------------------------------------------------------------------
;        inicializace font
; -----------------------------------------------------------------------------

InitFont PROC      NEAR

; ------ nvrat text z bufferu

         push      ds
         push      cs
         pop       es
         xor       si,si
         mov       ds,ds:[BuffTxt]
         mov       di,offset TextBeg
         mov       cx,offset(TextEnd-TextBeg)
         cld
         rep       movsb                    ; nvrat text
         pop       ds

; ------ stanoven konverzn tabulky pro texty

         mov       byte ptr ds:[SelChar],"*" ; znak pro oznaen vbru voleb
         mov       bx,offset TbKamLat       ; konverze na kd Latin 2
         cmp       byte ptr ds:[ParCest],3  ; je kd Latin 2 ?
         je        InitFnt2                 ; je kd Latin 2
         mov       byte ptr ds:[SelChar],"" ; znak pro oznaen vbru voleb
         mov       bx,offset TbKamCS0       ; tabulka k odstrann diakritiky
         cmp       byte ptr ds:[ParCest],0  ; je bez diakritiky ?
         je        InitFnt2                 ; je bez diakritiky
         cmp       byte ptr ds:[ParCest],1  ; je vlastn diakritika ?
         jne       InitFnt5                 ; nen vlastn - je Kamenickch
         cmp       byte ptr ds:[EgaVga],0   ; je karta EGA nebo VGA ?
         jne       InitFnt5                 ; je EGA nebo VGA

; ------ pekonvertovn text

InitFnt2:mov       si,offset TextBeg
         mov       cx,offset(TextEnd-TextBeg)
InitFnt3:lodsb
         sub       al,128
         jb        InitFnt4
         xlat
         mov       ds:[si-1],al
InitFnt4:loop      InitFnt3

; ------ inicializace videomdu

InitFnt5:call      MouseOff                 ; vypnut kurzoru myi
         mov       ah,0fh
         call      Int10                    ; poskytnut aktivnho videomdu

         mov       byte ptr ds:[SegmVRAM+1],0b0h
         cmp       al,7
         je        InitFnt6
         mov       byte ptr ds:[SegmVRAM+1],0b8h
         cmp       al,2
         je        InitFnt6
         mov       al,3
InitFnt6:mov       ah,0
         call      Int10                    ; inicializace videomdu

; ------ pedefinovn vlastnch font

         cmp       byte ptr ds:[ParCest],1  ; jsou vlastn fonty ?
         jne       InitFnt9                 ; nejsou vlastn fonty
         cmp       byte ptr ds:[EgaVga],0   ; je karta EGA/VGA ?
         je        InitFnt9                 ; nen karta EGA/VGA

         xor       ax,ax
         mov       es,ax                    ; ES <- 0
         mov       bh,14                    ; 14 bajt na znak
         cmp       es:[485h],bh             ; je 14 linek na znak ?
         mov       bp,offset Font14         ; font 14 linek na znak
         je        InitFnt8                 ; je 14 linek na znak

         cmp       byte ptr es:[485h],16
         je        InitFnt7                 ; je font 16 linek na znak
         mov       ax,1114h
         mov       bl,0
         call      Int10                    ; naten standard. fontu 16 linek
InitFnt7:mov       bp,offset Font16         ; font 16 linek na znak
         mov       bh,16                    ; 16 bajt na znak

InitFnt8:mov       cx,128                   ; poet znak k pedefinovn
         mov       dx,cx                    ; poten znak k pedefinovn
         mov       ax,1110h                 ; naten uivatelskch font
         push      cs
         pop       es                       ; ES <- CS
         mov       bl,0                     ; blok fontu
         call      Int10                    ; pedefinovn font

; ------ zobrazen univerzln sti

InitFnt9:call      MouseOn                  ; zapnut kurzoru myi
         call      DispRam                  ; zobrazen podkladovho rmu
         call      DispPod                  ; zobrazen podkladu
         call      DispVol                  ; zobrazen voleb
         call      KurzOff                  ; vypnut kurzoru
         ret

InitFont ENDP

; -----------------------------------------------------------------------------
;        obsluha zobrazen asu bhem INT 08h
; -----------------------------------------------------------------------------

Int08    PROC      FAR

; ------ voln pvodn obsluhy

         pushf
         call      dword ptr cs:[Old08]

; ------ tn zobrazen asu

         dec       byte ptr cs:[CitSek]
         jz        Int081
         iret

; ------ schova registr

Int081:  push      ax
         push      bx
         push      cx
         push      dx
         push      ds

; ------ aktuln stav tae asu

         xor       ax,ax
         mov       ds,ax                    ; DS <- 0
         mov       ax,ds:[046ch]            ; ten ni sti tae asu
         mov       dx,ds:[046eh]            ; ten vy sti tae asu

         push      cs
         pop       ds                       ; DS <- datov segment

         mov       cl,4                     ; poet rotac
         shl       dx,cl                    ; vy slovo * 16
         mov       bx,ax                    ; ni slovo tae asu
         mov       cl,12
         shr       bx,cl                    ; nejvy 4 bity niho slova
         add       dx,bx                    ; penos 4 bit do vyho slova
         mov       cl,4
         shl       ax,cl                    ; ni slovo * 16
         mov       bx,17478
         div       bx                       ; ta asu / 1092.375
         push      dx                       ; schova zbytku v minut
         mov       bx,60                    ; poet minut v hodin
         xor       dx,dx                    ; DX <- 0, AX=poet minut
         div       bx                       ; vpoet hodiny a minuty
         push      dx                       ; schova minuty

                                          ;* zobrazen daje hodin
         mov       dx,1*HI+69               ; poten pozice textu
         mov       ah,ds:[ColDat]
         call      Disp2Nm0
         mov       al,":"                   ; oddlovac znak
         call      Disp1Chr                 ; zobrazen oddlovacho znaku

                                          ;* zobrazen daje minut
         pop       ax                       ; nvrat minut
         mov       ah,ds:[ColDat]
         call      Disp2Nm0
         mov       al,":"                   ; oddlovac znak
         call      Disp1Chr                 ; zobrazen oddlovacho znaku

                                          ;* zobrazen daje sekund
         pop       ax                       ; nvrat zbytku do 1 minuty
         push      dx                       ; schova pozice textu
         mov       bx,60                    ; poet sekund v minut
         mul       bx                       ; vpoet potu sekund a setin
         mov       bx,17478                 ; pevod na abs. daj
         div       bx                       ; vpoet potu sekund

                                          ;* vpoet sti sekundy
         push      ax                       ; schova potu sekund
         mov       ax,dx                    ; zbytek do 1 sekundy
         mov       bx,18                    ; poet impuls v 1 sekund
         mul       bx                       ; vpoet potu impuls v sekund
         mov       bx,17478                 ; pevod na abs. daj
         div       bx                       ; vpoet potu sti sekundy
         sub       al,18                    ; -zbytek do sekundy
         neg       al                       ; zbytek do sekundy
         inc       al
         mov       ds:[CitSek],al           ; ta obsluhy hodin
         pop       ax                       ; nvrat potu sekund

         pop       dx                       ; nvrat pozice textu
         mov       ah,ds:[ColDat]
         call      Disp2Nm0

; ------ pprava k zobrazen uplynul doby akce

         cmp       byte ptr ds:[ParsTime],0 ; zobraz se uplynul as ?
         je        Int089                   ; nezobraz se

; ------ vpoet potu minut

         xor       ax,ax
         mov       ds,ax
         mov       ax,ds:[46ch]
         push      cs
         pop       ds
         sub       ax,ds:[BegTime]          ; uplynul doba
         xor       dx,dx
         mov       cx,1092                  ; poet impuls na minutu
         div       cx                       ; vpoet potu minut
         push      dx

         mov       dx,19*HI+67
         xor       bx,bx
         mov       ah,0
         mov       cl,2                     ; ka pole
         mov       ch,ds:[ColRF0]
         call      DispNum

; ------ oddlovac teka

         mov       ah,ch
         mov       al,":"
         call      Disp1Chr

; ------ zobrazen daje sekund

         pop       ax
         mov       cl,18
         div       cl
         mov       ah,ch
         call      Disp2Nm0

; ------ nvrat registr

Int089:  pop       ds
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         iret

Int08    ENDP

; 
;
;                   Univerzln obsluha klvesnice a myi
;
; 
;
; -----------------------------------------------------------------------------
;        vyprzdnn bufferu klvesnice
; -----------------------------------------------------------------------------

FlushKey PROC      NEAR

         push      bx

FlshKey1:call      TestKey                  ; test, zda je pipraven znak
         jc        FlshKey2                 ; nen dal znak z klvesnice
         call      InpKey                   ; zruen znaku z klvesnice
         jmp       short FlshKey1           ; test dalho znaku

FlshKey2:pop       bx
         ret

FlushKey ENDP

; -----------------------------------------------------------------------------
;      test, zda je pipraven znak z klvesnice (CY=nen, jinak BX=kd klvesy)
; -----------------------------------------------------------------------------

TestKey  PROC      NEAR

         push      ax

; ------ nulovn pznaku stisku INSERT (pro opakovn klvesy INSERT)

         push      ds
         xor       ax,ax
         mov       ds,ax                    ; DS <- 0
         and       byte ptr ds:[418h],not b7 ; nulovn pznaku stisku INSERT
         pop       ds

; ------ test znaku z klvesnice

         mov       ah,1
         int       16h                      ; test stavu klvesnice
         jnz       TestKey2                 ; je pipravena klvesa

; ------ obsluha bhem ekn na klvesu

         call      Int28                    ; obsluha bhem ekn na znak
         mov       ah,1
         int       16h                      ; test stavu klvesnice
         jnz       TestKey2                 ; je pipravena klvesa
         stc                                ; pznak - nen klvesa
         pop       ax
         ret

TestKey2:cmp       al,0
         je        TestKey3
         mov       ah,0
TestKey3:clc
         xchg      ax,bx
         pop       ax
         ret

TestKey  ENDP

; -----------------------------------------------------------------------------
;        vstup znaku z klvesnice -> BX
; -----------------------------------------------------------------------------

InpKey   PROC      NEAR

         push      ax

; ------ ekn na vstup znaku z klvesnice

InpKey1: sti
         call      TestKey                  ; test znaku z klvesnice
         jc        InpKey1

; ------ vstup znaku z klvesnice

InpKey2: mov       ah,0
         int       16h

; ------ korekce kdu klvesy

         cmp       al,0
         je        InpKey3
         mov       ah,0
InpKey3: call      UpCase

; ------ nhrada klvesy Ctrl-Break klvesou Esc

         or        ax,ax                    ; je klvesa Ctrl-Break ?
         jnz       InpKey4                  ; nen klvesa Ctrl-Break
         mov       ax,1bh                   ; nhrada klvesou Esc

InpKey4: xchg      ax,bx                    ; BX <- klvesa
         pop       ax
         ret

InpKey   ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 28h s schovou registr
; -----------------------------------------------------------------------------

Int28    PROC      NEAR

         pushf
         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      ds
         push      es

         int       28h

         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         popf
         ret

Int28    ENDP

; -----------------------------------------------------------------------------
;        inicializace obsluhy myi
; -----------------------------------------------------------------------------

InitMous PROC      NEAR

; ------ kontrola adresy INT 33h, zda je platn

         mov       ax,3533h
         int       21h                      ; poskytnut adresy INT 33h
         mov       ax,es                    ; segment adresy
         cmp       ax,60h                   ; minimln segment
         jb        IniMous1                 ; neplatn adresa INT 33h
         inc       bx                       ; offset 0ffffh je tak neplatn
         jz        IniMous1                 ; neplatn adresa INT 33h

; ------ test instalace myi

         mov       al,0
         call      Int33                    ; test instalace myi
         inc       ax                       ; je my nainstalovan ?
         jz        IniMous2                 ; my je nainstalovan OK
IniMous1:mov       byte ptr ds:[MouseIns],0 ; pznak - nen instalovan my
         ret

IniMous2:mov       byte ptr ds:[MouseIns],1 ; pznak nainstalovan myi

; ------ definovn kurzoru myi

         mov       al,10
         xor       bx,bx                    ; pznak softwarovho kurzoru
         mov       cx,0ffffh                ; maska obrazovky (AND)
         mov       dx,7700h                 ; maska kurzoru (XOR)
         call      Int33                    ; instalace rozmr okna

; ------ definice vertiklnch rozmr okna

         mov       al,8
         xor       cx,cx                    ; minimln dek
         mov       dx,24*8                  ; maximln dek okna
         call      Int33                    ; definice dk okna

; ------ definice horizontlnch rozmr okna

         mov       al,7
         xor       cx,cx                    ; minimln pozice
         mov       dx,79*8                  ; maximln pozice okna
         call      Int33                    ; definovn pozic okna

; ------ nastaven pozice kurzoru myi

         mov       al,4
         xor       cx,cx
         xor       dx,dx
         mov       ds:[MousePoz],dx         ; nulovn pozice kurzoru myi
         call      Int33                    ; nastaven pozice kurzoru myi

; ------ zapnut kurzoru myi

         mov       byte ptr ds:[MouseAkt],0 ; pznak - kurzor myi nen zapnut
         call      MouseOn                  ; zapnut kurzoru myi

IniMous9:ret

InitMous ENDP

; -----------------------------------------------------------------------------
;        zapnut kurzoru myi
; -----------------------------------------------------------------------------

MouseOn  PROC      NEAR

; ------ test, zda lze kurzor myi zapnout

         cmp       byte ptr ds:[MouseIns],0 ; je my nainstalovan ?
         je        MouseOn9                 ; my nen nainstalovan
         cmp       byte ptr ds:[MouseAkt],0 ; je kurzor myi zapnut ?
         jne       MouseOn9                 ; kurzor mui je ji zapnut

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ zapnut kurzoru myi

         mov       al,1
         call      Int33                    ; zapnut kurzoru myi
         mov       byte ptr ds:[MouseAkt],1 ; pznak zapnut kurzoru myi

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
MouseOn9:ret

MouseOn  ENDP

; -----------------------------------------------------------------------------
;        vypnut kurzoru myi
; -----------------------------------------------------------------------------

MouseOff PROC      NEAR

; ------ test, zda lze kurzor myi vypnout

         cmp       byte ptr ds:[MouseIns],0 ; je my nainstalovan ?
         je        MouseOf9                 ; my nen nainstalovan
         cmp       byte ptr ds:[MouseAkt],0 ; je kurzor myi zapnut ?
         je        MouseOn9                 ; kurzor mui je ji vypnut

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ vypnut kurzoru myi

         mov       al,2
         call      Int33                    ; vypnut kurzoru myi
         mov       byte ptr ds:[MouseAkt],0 ; pznak vypnut kurzoru myi

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
MouseOf9:ret

MouseOff ENDP

; -----------------------------------------------------------------------------
;        poskytnut stavu myi -> BX (CY=nen dn zmna)
; -----------------------------------------------------------------------------
; VSTUP:  BX:  0 = nebyla dn zmna (nastaven CY)
;               1 = zmna souadnic myi
;               2 = uvolnn nkterho tlatka
;               3 = stisk levho tlatka
;               4 = stisk pravho tlatka
;               5 = stisk stednho tlatka
;               6 = druh stisk levho tlatka
;               7 = druh stisk pravho tlatka
;               8 = druh stisk stednho tlatka
;          DX=aktuln souadnice kurzoru myi (DL=pozice, DH=dek)
; -----------------------------------------------------------------------------

MouseGet PROC      NEAR

; ------ test, zda je my nainstalovan

         cmp       byte ptr ds:[MouseIns],0 ; je my nainstalovan ?
         jne       MouseGt2                 ; my je nainstalovan
         xor       dx,dx                    ; aktuln pozice kurzoru myi
         xor       bx,bx                    ; pznak - nen zmna
         stc                                ; pznak, e nen dn zmna
         ret

; ------ schova registr

MouseGt2:push      ax
         push      cx

; ------ zjitn aktulnho stavu myi

         mov       al,3
         call      Int33                    ; navrcen aktulnho stavu myi

; ------ vpoet aktulnch souadnic myi

         shr       cx,1
         shr       cx,1
         shr       cx,1
         shr       dx,1
         shr       dx,1
         shr       dx,1
         mov       dh,dl                    ; aktuln dek
         mov       dl,cl                    ; aktuln pozice

; ------ schova aktulnho stavu tlatek

         and       bx,7                     ; pouze platn bity
         mov       al,bl                    ; nov stav tlatek
         xchg      bl,ds:[MouseKey]         ; uloen novho stavu tlatek
         mov       ah,bl                    ; star stav tlatek
         mov       cx,ax                    ; schova starho a novho stavu
         not       ah                       ; maska - uvolnn tlatka
         and       al,ah                    ; stisknut tlatka
         jz        MouseGt5                 ; nebyl stisk dnho tlatka

; ------ porovnn asu pedelho stisku tlatka

         push      ax
         push      ds
         xor       ax,ax
         mov       ds,ax
         mov       ax,ds:[46ch]             ; as
         pop       ds
         sub       ax,ds:[MouseTim]         ; uplynul doba
         add       ds:[MouseTim],ax         ; nov aktuln as
         cmp       ax,4                     ; byla asi 1/4 sekundy ?
         pop       ax
         mov       bl,3                     ; pznak - stisk levho tlatka
         ja        MouseGt4                 ; byl del as
         mov       bl,6                     ; pznak - druh stisk tlatka

; ------ rozlien, zda bylo nkter tlatko stisknuto

MouseGt4:shr       al,1                     ; stisknuto lev tlatko ?
         jc        MouseGt6                 ; stisknuto lev tlatko
         inc       bx                       ; pznak - stisk pravho tlatka
         shr       al,1                     ; stisknuto prav tlatko ?
         jc        MouseGt6                 ; stisknuto prav tlatko
         inc       bx                       ; pznak - stisk stednho tlatka
         shr       al,1                     ; stisknuto stedn tlatko ?
         jc        MouseGt6                 ; stisknuto stedn tlatko

; ------ test, zda bylo nkter tlatko uvolnno

MouseGt5:mov       bl,2                     ; pznak uvolnn tlatka
         not       cl                       ; maska uvolnnch tlatek
         and       cl,ch                    ; bylo nkter tlatko uvolnno ?
         jnz       MouseGt6                 ; bylo nkter tlatko uvolnno
         xor       bx,bx                    ; jinak dn zmna

; ------ uloen novch souadnic myi a rozlien stavu

MouseGt6:or        bx,bx                    ; byla njak zmna tlatek ?
         mov       cx,ds:[MousePoz]         ; schova starch souadnic myi
         mov       ds:[MousePoz],dx         ; uloen novch souadnic myi
         jnz       MouseGt8                 ; byla njak zmna tlatek
         cmp       dx,cx                    ; byla zmna souadnic myi ?
         stc                                ; pznak, e nebyla dn zmna
         je        MouseGt8                 ; nebyla zmna souadnic myi
         inc       bx                       ; BX <- 1 pznak zmny souadnic
         clc                                ; pznak, e byla njak zmna

; ------ nvrat registr

MouseGt8:pop       cx
         pop       ax
         ret

MouseGet ENDP

; -----------------------------------------------------------------------------
;        voln obsluhy INT 33h s schovou registr (funkce v AL)
; -----------------------------------------------------------------------------

Int33    PROC      NEAR

         pushf
         push      si
         push      di
         push      bp
         push      ds
         push      es

         sti
         mov       ah,0
         int       33h

         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         popf
         ret

Int33    ENDP

; 
;
;                     Univerzln obsluha displeje
;
; 
;
; -----------------------------------------------------------------------------
;        vypnut kurzoru
; -----------------------------------------------------------------------------

KurzOff  PROC      NEAR

         push      dx
         mov       dx,25*256                ; prvn dek "za rohem"
         call      SetKurz                  ; nastaven pozice kurzoru
         pop       dx
         ret

KurzOff  ENDP

; -----------------------------------------------------------------------------
;        nastaven pozice kurzoru DX
; -----------------------------------------------------------------------------

SetKurz  PROC      NEAR

         push      ax
         push      bx
         mov       bh,0                     ; aktivn videostrnka 0
         mov       ah,2                     ; funkce - nastaven pozice kurzoru
         call      Int10                    ; nastaven pozice kurzoru
         pop       bx
         pop       ax
         ret

SetKurz  ENDP

; -----------------------------------------------------------------------------
;        zobrazen hexadecimlnho bajtu AL (AH=barva, DX=pozice)
; -----------------------------------------------------------------------------

DispHByt PROC      NEAR

         push      ax
         shr       al,1
         shr       al,1
         shr       al,1
         shr       al,1
         call      DispHx
         pop       ax
         call      DispHx
         ret

DispHByt ENDP

; -----------------------------------------------------------------------------
;        zobrazen hexadecimlnho znaku AL (AH=barva, DX=pozice)
; -----------------------------------------------------------------------------

DispHx   PROC      NEAR

         push      ax
         and       al,0fh
         cmp       al,10
         jb        DispHx2
         add       al,7
DispHx2: add       al,"0"
         call      Disp1Chr
         pop       ax
         ret

DispHx   ENDP

; -----------------------------------------------------------------------------
;        zobrazen sla AL 2 slice s dosplnnm nuly (AH=barva)
; -----------------------------------------------------------------------------

Disp2Nm0 PROC      NEAR

; ------ dekdovn sla

         push      cx
         push      ax

         mov       ah,0
         mov       cl,10
         div       cl                       ; vpoet slic
         add       ax,"00"                  ; korekce na ASCII slice
         xchg      ax,cx

         pop       ax

; ------ zobrazen slice destek

         mov       al,cl                    ; destky
         call      Disp1Chr                 ; zobrazen slice destek

; ------ zobrazen slice jednotek

         mov       al,ch                    ; jednotky
         call      Disp1Chr                 ; zobrazen slice jednotek
         pop       cx
         ret

Disp2Nm0 ENDP

; -----------------------------------------------------------------------------
;        zobrazen sla AL 2 slice s doplnnm mezery (AH=barva)
; -----------------------------------------------------------------------------

Disp2NmS PROC      NEAR

; ------ dekdovn sla

         push      cx
         push      ax

         mov       ah,0
         mov       cl,10
         div       cl                       ; vpoet slic
         add       ax,"00"                  ; korekce na ASCII slice
         xchg      ax,cx

         pop       ax

; ------ zobrazen slice destek

         mov       al,cl                    ; destky
         cmp       al,"0"                   ; je prvn znak nula ?
         jne       Disp2NS2                 ; nen nula
         mov       al," "                   ; nhrada nuly mezerou
Disp2NS2:call      Disp1Chr                 ; zobrazen slice destek

; ------ zobrazen slice jednotek

         mov       al,ch                    ; jednotky
         call      Disp1Chr                 ; zobrazen slice jednotek
         pop       cx
         ret

Disp2NmS ENDP

; -----------------------------------------------------------------------------
;        zobrazen sla BX:AX; CL=ka pole, CH=barva, DX=pozice (zmn se)
; -----------------------------------------------------------------------------

DispNum  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      si
         push      di
         push      bp

; ------ pprava registr

         mov       di,dx                    ; DI <- schova pozice na displeji
         mov       dx,bx                    ; slo HIGH
         xchg      ax,bp                    ; BP <- slo LOW
         mov       si,10                    ; SI = dlitel
         mov       bh,ch                    ; BH <- barva
         mov       ch,0                     ; CH = ta slic, CL = ka
         mov       bl,"."                   ; BL = znak mezery, BH = barva

; ------ vpoet jedn slice

DispNum1:xchg      ax,dx                    ; AX <- slo HIGH
         xor       dx,dx                    ; DX <- 0
         div       si                       ; vydlen sla HIGH
         xchg      ax,bp                    ; AX <- nvrat LOW, BP<-schova HIGH
         div       si                       ; vydlen sla LOW

; ------ oddlova d

         cmp       ch,3
         je        DispNum2                 ; jsou tisce
         cmp       ch,7
         jne       DispNum3                 ; nejsou miliony
DispNum2:push      bx                       ; uloen oddlovac teky
         inc       ch                       ; zven tae znak v zsobnku

; ------ uloen sla

DispNum3:add       dl,"0"                   ; korekce na znak ASCII
         mov       dh,bh                    ; barva
         push      dx                       ; uloen sla do zsobnku
         inc       ch                       ; zven tae slic v zsobnku
         mov       dx,bp                    ; DX <- nvrat sla HIGH
         xchg      ax,bp                    ; BP <- slo LOW, (AX <- HIGH)

; ------ test, zda bude dal slice

         or        ax,bp                    ; je slo ji = 0 ?
         jnz       DispNum1                 ; dekdovn dal slice

; ------ zobrazen vodnch mezer

         mov       dx,di                    ; nvrat pozice na displeji
         push      cx
         sub       cl,ch                    ; odeten slic k zobrazen
         mov       ch,0
         jbe       DispNum4                 ; nezbyly dn mezery
         mov       ah,bh                    ; barva
         mov       al," "                   ; mezera k vymazn bufferu
         call      DispChr                  ; zobrazen vodnch mezer
DispNum4:pop       ax
         mov       cl,ah                    ; CX = poet znak v zsobnku

; ------ zobrazen sla

DispNum6:pop       ax
         call      Disp1Chr
         loop      DispNum6                  ; dal znak

; ------ nvrat registr

         pop       bp
         pop       di
         pop       si
         pop       cx
         pop       bx
         pop       ax
         ret

DispNum  ENDP

; -----------------------------------------------------------------------------
;        zobrazen stnu pod oknem (potek DX, rozmry CX)
; -----------------------------------------------------------------------------

StinWin  PROC      NEAR

; ------ zobrazen stnu po prav stran okna

         push      cx
         push      dx
         add       dl,cl                    ; pozice za oknem
         inc       dh                       ; druh dek okna
         mov       cl,2                     ; ka stnu 2 pozice
StinWin1:call      DispStin                 ; zobrazen stnu na jednom dku
         inc       dh                       ; zven ukazatele dku
         dec       ch                       ; snen tae vky okna
         jnz       StinWin1                 ; stn na dalm dku
         pop       dx
         pop       cx

; ------ zobrazen stnu pod oknem

         push      cx
         push      dx
         add       dh,ch                    ; dek pod oknem
         add       dl,2                     ; poten pozice
         sub       cl,2                     ; snen ky o 2
         call      DispStin                 ; zobrazen stnu
         pop       dx
         pop       cx
         ret

StinWin  ENDP

; -----------------------------------------------------------------------------
;        Zobrazen stnu (DX=pozice, CL=dlka, DL se nezmn)
; -----------------------------------------------------------------------------

DispStin PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      di
         push      es

; ------ vpoet adresy ve videopamti

         mov       es,ds:[SegmVRAM]         ; segment videopamti
         mov       al,80                    ; poet znak na dek
         mul       dh                       ; pepoet dk na pozice
         add       al,dl                    ; piten pozice
         adc       ah,0
         shl       ax,1                     ; * 2 = offset ve videostrnce
         xchg      ax,di                    ; adresa ve videopamti

; ------ zpis stnu

         cld                                ; smr posunu ukazatele nahoru
         mov       ch,0
         jcxz      DispStn7                 ; nen dn znak k zpisu
         mov       al,7                     ; barva stnu
DispStn6:inc       di                       ; peskoen znaku
         stosb                              ; zpis stnu
         loop      DispStn6                 ; zpis dalho stnu

; ------ nvrat registr, konec

DispStn7:pop       es
         pop       di
         pop       cx
         pop       ax
         ret

DispStin ENDP

; -----------------------------------------------------------------------------
;        Zobrazen jednoho znaku AX (DX=pozice, DL se zmn)
; -----------------------------------------------------------------------------

Disp1Chr PROC      NEAR

; ------ schova registr

         push      di
         push      es

; ------ vpoet adresy ve videopamti

         push      ax
         mov       es,ds:[SegmVRAM]         ; segment videopamti
         mov       al,80                    ; poet znak na dek
         mul       dh                       ; pepoet dk na pozice
         add       al,dl                    ; piten pozice
         adc       ah,0
         shl       ax,1                     ; * 2 = offset ve videostrnce
         xchg      ax,di                    ; adresa ve videopamti
         pop       ax

; ------ zobrazen znaku

         cld                                ; smr posunu ukazatele nahoru
         stosw                              ; zpis znaku bez kontroly snen

; ------ nvrat registr, konec

         pop       es
         pop       di
         inc       dx                       ; zven pozice
         ret

Disp1Chr ENDP

; -----------------------------------------------------------------------------
;        Zobrazen znaku AX (DX=pozice, CL=poet znak, DL se zmn)
; -----------------------------------------------------------------------------

DispChr  PROC      NEAR

; ------ schova registr

         push      cx
         push      di
         push      es

; ------ vpoet adresy ve videopamti

         push      ax
         mov       es,ds:[SegmVRAM]         ; segment videopamti
         mov       al,80                    ; poet znak na dek
         mul       dh                       ; pepoet dk na pozice
         add       al,dl                    ; piten pozice
         adc       ah,0
         shl       ax,1                     ; * 2 = offset ve videostrnce
         xchg      ax,di                    ; adresa ve videopamti
         pop       ax

; ------ zobrazen znaku

         cld                                ; smr posunu ukazatele nahoru
         mov       ch,0                     ; CX = poet znak k zobrazen
         rep       stosw                    ; zpis znaku bez kontroly snen

; ------ nvrat registr, konec

         pop       es
         pop       di
         pop       cx
         add       dl,cl                    ; zven pozice
         ret

DispChr  ENDP

; -----------------------------------------------------------------------------
;   zobrazen textu DS:SI s dlkou (DX=pozice, AH=barva, CH=vysvcen barva)
; -----------------------------------------------------------------------------

Disp0Txt PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      di
         push      es

; ------ vpoet adresy ve videopamti

         mov       es,ds:[SegmVRAM]         ; segment videopamti
         push      ax                       ; schova atributu barvy
         mov       al,80                    ; poet znak na dek
         mul       dh                       ; pepoet dk na pozice
         add       al,dl                    ; piten pozice
         adc       ah,0
         shl       ax,1                     ; * 2 = offset ve videostrnce
         xchg      ax,di                    ; DI <- adresa ve videopamti
         pop       ax                       ; AH = atribut barvy

; ------ pprava parametr textu

         cld                                ; smr posunu ukazatele nahoru
         mov       bh,ch                    ; alternativn barva
         mov       ch,0
         lodsb
         mov       cl,al                    ; poet bajt textu

; ------ zobrazen textu

         jcxz      Disp0Tx7                 ; nen dn znak k zobrazen
Disp0Tx3:lodsb                              ; znak k zobrazen
         or        al,al                    ; je pepna barvy ?
         jnz       Disp0Tx4                 ; nen pepna barvy
         xchg      ah,bh                    ; zmna barvy
         jmp       short Disp0Tx5
Disp0Tx4:stosw                              ; uloen znaku
         inc       dx                       ; zven ukazatele pozice
Disp0Tx5:loop      Disp0Tx3                 ; penos dat bez kontroly snen

; ------ nvrat registr, konec

Disp0Tx7:pop       es
         pop       di
         pop       cx
         pop       bx
         pop       ax
         ret

Disp0Txt ENDP

; -----------------------------------------------------------------------------
;  Zobrazen textu DS:SI (AH=barva, DX=pozice, CL=poet znak, DL a SI se zmn)
; -----------------------------------------------------------------------------

DispTxt  PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      di
         push      es
         mov       ch,0                     ; CX = poet znak

; ------ vpoet adresy ve videopamti

         mov       es,ds:[SegmVRAM]         ; segment videopamti
         push      ax                       ; schova atributu barvy
         mov       al,80                    ; poet znak na dek
         mul       dh                       ; pepoet dk na pozice
         add       al,dl                    ; piten pozice
         adc       ah,0
         shl       ax,1                     ; * 2 = offset ve videostrnce
         xchg      ax,di                    ; DI <- adresa ve videopamti
         pop       ax                       ; AH = atribut barvy

; ------ zobrazen textu

         mov       ch,0
         jcxz      DispTxt7
         cld                                ; smr posunu ukazatele nahoru
DispTxt6:lodsb                              ; znak k zobrazen
         stosw                              ; uloen znaku
         loop      DispTxt6                 ; penos dat bez kontroly snen

; ------ nvrat registr, konec

DispTxt7:pop       es
         pop       di
         pop       cx
         pop       ax
         add       dl,cl                    ; zven pozice
         ret

DispTxt  ENDP

; -----------------------------------------------------------------------------
;        Detekce videokarty EGA/VGA
; -----------------------------------------------------------------------------

DetCard  PROC      NEAR

         mov       ah,12h                   ; sluba EGA/VGA - informace o EGA
         mov       bx,4510h                 ; poskytnut informac o EGA
         call      Int10                    ; poskytnut informac o EGA/VGA
         cmp       bh,1                     ; kontrola navrcenho mdu displeje
         ja        DetCard1                 ; nen to karta EGA/VGA
         cmp       bl,3                     ; maximln povolen 1 MB pamti
         ja        DetCard1                 ; nen to karta EGA/VGA
         inc       byte ptr ds:[EgaVga]     ; 1=pznak karty EGA/VGA
DetCard1:ret

DetCard  ENDP

; -----------------------------------------------------------------------------
;        Voln INT 10h s schovou registr
; -----------------------------------------------------------------------------

Int10    PROC      NEAR

         pushf
         push      si
         push      di
         push      bp
         push      ds
         push      es

         int       10h

         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         popf
         ret

Int10    ENDP

; 
;
;                       Rzn univerzln procedury
;
; 
;
; -----------------------------------------------------------------------------
;        pevod znaku AL na velk psmeno
; -----------------------------------------------------------------------------

UpCase   PROC      NEAR

         cmp       al,"a"
         jb        UpCase2
         cmp       al,"z"
         ja        UpCase2
         sub       al,32
UpCase2: ret

UpCase   ENDP

; -----------------------------------------------------------------------------
;                    skok na obsluhu podle BX
; -----------------------------------------------------------------------------
; Procedura se vol instrukc CALL JumpBX, za kterou nsleduje tabulka
; skok. Procedura zmn svou nvratovou adresu na adresu podle nalezen
; poloky v tabulce (nebo podle poloky pro nenalezenou hodnotu).
; -----------------------------------------------------------------------------
; VSTUP: v zsobnku slovo (nvratov adresa NEAR) = zatek tabulky skok
;             stuktura tabulky: 1 slovo testovan hodnota BX
;                               1 slovo adresa NEAR obsluhy
;             konec tabulky: 1 slovo = 0 (pznak konce tabulky)
;                            1 slovo adresa NEAR obsluhy pi nenalezen kdu
; -----------------------------------------------------------------------------

JumpBX   PROC      NEAR

; ------ schova registr

                                            ; SS:[BP+4] = IP
         push      si                       ; SS:[BP+2] = SI
         push      bp                       ; SS:[BP+0] = BP
         mov       bp,sp

; ------ nalezen hodnoty v tabulce

         mov       si,ss:[bp+4]             ; offset adresy tabulky
JumpBX1: cmp       word ptr ds:[si],0       ; je konec tabulky ?
         je        JumpBX2                  ; konec tabulky - nenalezeno
         cmp       word ptr ds:[si],bx      ; je to hledan hodnota ?
         je        JumpBX2                  ; hodnota nalezena
         add       si,4                     ; adresa dal poloky
         jmp       short JumpBX1            ; test dal poloky

; ------ nastaven nvratov adresy podle tabulky

JumpBX2: mov       si,ds:[si+2]             ; adresa skoku
         mov       ss:[bp+4],si             ; nov nvratov adresa

; ------ nvrat registr

         pop       bp
         pop       si
         ret

JumpBX   ENDP

; -----------------------------------------------------------------------------
;        ekn po dobu CX (CX=poet impuls 1/18 sekundy)
; -----------------------------------------------------------------------------

Cekej    PROC      NEAR

         push      ax
         push      cx
         push      ds

         xor       ax,ax
         mov       ds,ax
         jcxz      Cekej3

Cekej1:  mov       ax,ds:[46ch]
         sti
Cekej2:  cmp       ax,ds:[46ch]
         je        Cekej2
         loop      Cekej1

Cekej3:  pop       ds
         pop       cx
         pop       ax
         ret

Cekej    ENDP

; -----------------------------------------------------------------------------
;        zapnut tnovho genertoru
; -----------------------------------------------------------------------------
; VSTUP: BX=dlic konstanta
;         dw        36485,34437,32505,30680,28958,27333 ; oktva 0
;         dw        25799,24351,22984,21694,20477,19327
;         dw        18243,17219,16252,15340,14479,13667 ; oktva 1
;         dw        12899,12175,11492,10847,10238,9664
;         dw        9121,8609,8126,7670,7240,6833       ; oktva 2
;         dw        6450,6088,5746,5424,5119,4832
;         dw        4561,4305,4063,3835,3620,3417       ; oktva 3
;         dw        3225,3044,2873,2712,2560,2416
;         dw        2280,2152,2032,1918,1810,1708       ; oktva 4
;         dw        1612,1522,1437,1356,1280,1208
;         dw        1140,1076,1016,959,905,854          ; oktva 5
;         dw        806,761,718,678,640,604
;         dw        570,538,508,479,452,427             ; oktva 6
;         dw        403,380,359,339,320,302
;         dw        285,269,254,240,226,214             ; oktva 7
;         dw        202,190,180,169,160,151
;         dw        143,135,127,120,113,107             ; oktva 8
;         dw        101,95,90,85,80,75
;         dw        71,67,63,60,57,53,50,48,45,42,40,38 ; oktva 9
; -----------------------------------------------------------------------------

Ton      PROC      NEAR

         cmp       byte ptr ds:[ParInd],0   ; je zvuk zapnut ?
         je        Ton9                     ; zvuk je vypnut
         push      ax
         mov       al,0b6h
         out       [43h],al
         mov       al,bl
         out       [42h],al
         mov       al,bh
         out       [42h],al
         in        al,[61h]
         or        al,3
         out       [61h],al
         pop       ax
Ton9:    ret

Ton      ENDP

; -----------------------------------------------------------------------------
;        vypnut zvukovho genertoru
; -----------------------------------------------------------------------------

TonOff   PROC      NEAR

         push      ax
         in        al,[61h]
         and       al,not 3
         out       [61h],al                 ; vypnut genertoru
         pop       ax
         ret

TonOff   ENDP

; -----------------------------------------------------------------------------
;        inicializace genertoru nhody
; -----------------------------------------------------------------------------

InitRnd  PROC      NEAR

         push      ax
         push      ds
         xor       ax,ax
         mov       ds,ax
         mov       ax,ds:[46ch]             ; ta systmovho asovae
         pop       ds
         mov       word ptr ds:[RandomR],ax ; inicializan konstanta
         pop       ax
         ret

InitRnd  ENDP

; -----------------------------------------------------------------------------
;        genertor nhodnho sektoru ES:DI (512 bajt) -> DI nov adresa
; -----------------------------------------------------------------------------

RandomS  PROC      NEAR

         push      ax
         push      bx
         push      cx
         push      dx
         push      bp
         push      si

         cld
         mov       si,256                   ; poet slov ke generovn
         mov       bp,8405h                 ; pomocn konstanta
         mov       ax,word ptr ds:[RandomR]
         mov       dx,word ptr ds:[RandomR+2]

RandomS1:mov       bx,dx
         mov       cx,ax
         mul       bp
         shl       cx,1
         shl       cx,1
         shl       cx,1
         add       ch,cl
         add       dx,cx
         add       dx,bx
         shl       bx,1
         shl       bx,1
         add       dx,bx
         add       dh,bl
         mov       cl,5
         shl       bx,cl
         add       dh,bl
         add       ax,1
         adc       dx,0

         xchg      ax,dx
         stosw
         xchg      ax,dx

         dec       si
         jnz       RandomS1                 ; dal slovo

         mov       word ptr ds:[RandomR],ax
         mov       word ptr ds:[RandomR+2],dx

         pop       si
         pop       bp
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

RandomS  ENDP

; 
;
;                           BOOT sektor
;
; 
;
Boot:    jmp       Bstart

         db        'FORM 2.0'               ; identifikace

         dw        512                      ; dlka sektoru
BlokSekt db        2                        ; poet sektor na alokan blok
  ;BBlok    db        2                        ; velikost bloku (sektor)
         dw        1                        ; poet rezervovanch sektor
         db        2                        ; poet alok. tabulek FAT
RootMax  dw        70h                      ; maximln poloek ROOT
  ;BRoot    dw        70h                      ; max. poet poloek ROOT
CelkSekt dw        2*40*9                   ; celkov poet sektor mdia
  ;BNMax    dw        720                      ; celkem sektor na mdiu
Popis    db        0ffh                     ; popisova mdia
  ;BIdent   db        0fdh                     ; popisova mdia
FatSekt  db        2                        ; poet sektor na FAT
         db        0
  ;BNFat    dw        3                        ; poet sektor v jedn FAT
NumSekt  db        9                        ; poet sektor na stopu
         db        0                        ; doplnn na slovo
  ;BSekt    dw        9                        ; poet sektor na stopu
NumStran db        2                        ; poet stran disku
         db        0
  ;BStran   dw        2                        ; poet hlav disku
         dd        0                        ; skrytch sektor (4-bajty)
         dd        0                        ; celkem sektor (4-bajty)

         db        0                        ; disk (pracovn)
         db        0                        ; hlava (pracovn)

         db        29h                      ; identifiktor
BSerie   dd        0                        ; sriov slo

         db        'NO NAME    '
         db        'FAT12   '

Bstart:  xor       ax,ax
         mov       ss,ax
         mov       sp,7c00h
         sti

         push      ss
         pop       ds
         push      ss
         pop       es

         mov       si,offset(BText-Boot)+7c00h

BDispTxt:cld
         lodsb
         or        al,al
         jz        BRet
         mov       ah,0eh
         mov       bx,7
         int       10h
         jmp       short BDispTxt

BRet:    sti
         xor       ax,ax
         int       16h

         int       19h

BText    db        13
         db        'Nesystemova disketa. Vymente ji',13,10
         db        'a stisknete libovolnou klavesu.',13,10,0

BootEnd  label     byte

; 
;
;                                 Data
;
; 
;

INCLUDE  FONT14.ASM
INCLUDE  FONT16.ASM

; ------ konverzn tabulka z kdu Kamenickch na kd bez diakritiky

TbKamCS0 label     byte
         db        'CuedaDTceELIllAA'
         db        'EzZooOuUyOUSLYRt'
         db        'aiounNUOsrrR',172,173,174,175
         db        176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
         db        192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
         db        208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
         db        224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
         db        240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255

; ------ konverzn tabulka z kdu Kamenickch na kd Latin 2

TbKamLat label     byte
         db        172,'',212,'',210,155,159,216,183,145,214,150,146,'',181
         db        '',167,166,'',224,133,233,236,'',230,149,237,252,156
         db        '',229,213,222,226,231,253,234,232,'/',245,174,175
         db        176,177,178,179,180,179,186,187,191,185,186,187,188,188,217,191
         db        192,193,194,195,196,197,179,186,200,201,202,203,204,205,206,205
         db        188,205,196,200,192,218,201,186,205,217,218,219,220,219,219,223
         db        'a',225,'G','p','S','s','m','t','f','T','O','d','0','/','E','N'
         db        '=','+','>','<',218,217,246,'=',248,250,250,'V','n','2',254,255

; ------ chybov hlen pi startu programu

DiskTxt  db        'Neni nainstalovana zadna disketova mechanika !',13,10,'$'
MemTxt   db        'Chyba - nedostatek pameti ke spusteni programu !',13,10,'$'

SelChar  db        251                      ; znak pro oznaen vbru voleb

BuffTxt  dw        0                        ; adresa bufferu text

; -----------------------------------------------------------------------------
;        texty (bajty dlek se nekonvertuj, protoe jsou vdy < 128 !)
; -----------------------------------------------------------------------------

TextBeg  label     byte                     ; zatek text k transpozici

TextKap  db        6,'celkem'
TextVol  db        5,'volne'
TextBad  db        5,'vadne'
TextBoot db        4,'BOOT'
TextRoot db        4,'ROOT'
TextFat1 db        4,'FAT1'
TextFat2 db        4,'FAT2'
TextDob  db        4,'doba'

TextOK   db        2,' '
TextNOK  db        2,' x'
TextXOK  db        2,'  '

LicTxt   db        40,'FORM verze 2.00     (c) Miroslav Nmeek'
TextDisk db        5,'Disk '
TextAut  db        10,'utomatick'
TextStra db        7,'strana '

VolText  label     byte                     ; texty k volbm
         db        15,'Operan systm'
         db        13,'Nvt disku'
         db        13,'Zachovn dat'
         db        12,'Jedna strana'
         db        14,'Poloek v Root'
         db        16,'Zobrazen obsahu'
         db        15,'Zrychlen start'
         db        11,'Zptn smr'
         db        16,'Zvukov indikace'
         db        10,'Verifikace'
         db        16,'Doplujc stopy'
         db        15,'Testovac zpis'
         db        16,'Formtovac znak'
         db        17,'Optimalizace chyb'
         db        7,'etina'

VolHlp   label     byte                     ; npovdy k volbm
         db        39,'Instalace operanho systmu na disketu'
         db        38,'Zadn nvt disku (jmenovka, LABEL)'
         db        32,'Zachovn pvodnho obsahu disku'
         db        36,'Formtovn disku pouze jednostrann'
         db        38,'Poet poloek zkladnho adrese Root'
         db        39,'Zobrazen obsahu diskety k zformtovn'
         db        37,'Zrychlen start s pedrozbhem motoru'
         db        39,'Formtovn smrem od vych stop dol'
         db        37,'Zvukov indikace ukonen formtovn'
         db        37,'Kontroln ten stopy po zformtovn'
         db        38,'Poet doplujcch stop disku (0 a '
PocPHlp2 db        '6)'
         db        34,'Poet ovovacch zpis (0 a 99)'
         db        35,'Formtovac znak (HEX kd 00 a FF)'
         db        36,'Optimalizace sektor pi vzniku chyb'
         db        29,'Kd etiny k zobrazen text'

RootHlp  db        40,' Zadejte 16 a 992, 0=standardn formt '
PocPHlp  db        40,' Zadejte poet stop 0 a '
PocPHlp1 db        '6, 0=standard  '
PocZHlp  db        41,' Zadejte poet testovacch zpis 0 a 99'
HexFHlp  db        40,' Zadejte formtovac znak 00 a FF (HEX)'

VolHlp0  db        44,' (',0,'ENTER',0,'=zmna, ',0,'ESC',0,'=konec, ',0,'F1',0,'=npovda) '

FormHlpA db        37,' Autom. detekce formtu podle diskety'
FormHlp1 db        15,' 5 1/4" HD SS, '
FormHlp2 db        9,' B, Root '

FormHlp0 db        48,' (',0,'ENTER',0,'=formtuj, ',0,'ESC',0,'=konec, ',0,'F1',0,'=npovda) '

; -----------------------------------------------------------------------------
;        pepnae
; -----------------------------------------------------------------------------

VolTCest db        '          -'
         db        '    vlastn'
         db        'Kamenickch'
         db        '    Latin 2'

VolTStd  db        'STD'

TextEnd  label     byte                     ; konec text k transpozici

; -----------------------------------------------------------------------------
;        definice voleb
; -----------------------------------------------------------------------------
; Definice jedn poloky voleb:
;    0: (1) parametry poloky
;              bit 0: 1=pepna
;              bit 1: 1=dekadick poloka (bajt)
;              bit 2: 1=hexadecimln poloka (bajt)
;              bit 3: 1=volba etiny (poloky BEZ, DWN, KAM, LAT)
;                  (bit 4: 1=volba zachovn dat (poloky -, STOP, DISK))
;              bit 5: 1=poet poloek v ROOT
;    1: (2) adresa parametru poloky
;    3: (1) poten pozice k zobrazen volby
;    4: (1) poten dek k zobrazen volby
;    5: (1) offset pozice k zobrazen parametru poloky (na obrazovce)
;    6: (1) dlka pole parametru poloky (na obrazovce)
; -----------------------------------------------------------------------------

VolDef   label     byte
         db        b0
         dw        ParSys
         db        4,3,18,1

         db        b0
         dw        ParLab
         db        4,4,18,1

         db        b0
         dw        ParDat
         db        4,5,18,1

         db        b0
         dw        ParStra
         db        4,6,18,1

         db        b5
         dw        ParRoot
         db        4,7,16,3

         db        b0
         dw        ParObs
         db        28,3,19,1

         db        b0
         dw        ParStrt
         db        28,4,19,1

         db        b0
         dw        ParBack
         db        28,5,19,1

         db        b0
         dw        ParInd
         db        28,6,19,1

         db        b0
         dw        ParVerif
         db        28,7,19,1

         db        b1
         dw        ParStop
         db        53,3,22,1

         db        b1
         dw        ParTest
         db        53,4,21,2

         db        b2
         dw        ParChar
         db        53,5,21,2

         db        b0
         dw        ParOptim
         db        53,6,22,1

         db        b3
         dw        ParCest
         db        53,7,12,11
VolDef0  label     byte

; -----------------------------------------------------------------------------
;        schova aktulnho zobrazen data a asu
; -----------------------------------------------------------------------------

OldBreak db        1                        ; schova pznaku BREAK

CitSek   db        18                       ; ta k zobrazen sekund
Old08    dd        0                        ; pvodn adresa INT 08h

BegTime  dw        0                        ; as zatku akce (ni slovo)
;ElapsTim dw        0                        ; uplynul doba akce
ParsTime db        0                        ; pznak, e se zobraz doba akce

RandomR  dd        21510d31h                ; promnn pro genertor nhody

; -----------------------------------------------------------------------------
;        tabulka disketovch parametr
; -----------------------------------------------------------------------------

Old1e    dd        -1                       ; pvodn vektor INT 1eh

Int1e    label     byte                     ; vlastn tabulka INT 1eh
         db        0dfh                     ; bity 0 a 3: rychlost krokovn
                                            ; bity 4 a 7: as zvednut hlavy
         db        2                        ; bit 0: 1=je provoz DMA
                                            ; bity 1 a 7: as sputn hlavy
MotorOff db        37                       ; 2: vypnut motoru v 1/18 sekundy
         db        2                        ; 3: velikost sektoru
         db        9                        ; 4: poet sektor na stopu
         db        42                       ; 5: mezisekt. mezera ten/zpis
         db        255                      ; 6: dlka penench dat
         db        80                       ; 7: mezisekt. mezera formtovn
FillCh   db        0                        ; 8: plnic znak formtovn
         db        15                       ; 9: doba ustlen hlav v [ms]
MotorOn  db        8                        ; 10: doba pro rozbh motoru v 1/8s
         db        39                       ; 11: posledn stopa na disku
         db        80h                      ; 12: penosov rychlost

; -----------------------------------------------------------------------------
;        parametry displeje
; -----------------------------------------------------------------------------

         EVEN
SegmVRAM dw        0b800h                   ; segment videopamti
EgaVga   db        0                        ; 1=pznak, e je karta EGA/VGA

; -----------------------------------------------------------------------------
;        parametry myi
; -----------------------------------------------------------------------------

MousePoz dw        0                        ; aktuln pozice myi
MouseKey db        0                        ; aktuln stav tlatek
                                            ;   bit 0: 1=lev tlatko
                                            ;   bit 1: 1=prav tlatko
                                            ;   bit 2: 1=stedn tlatko
MouseTim dw        0                        ; as minulho stisku tlatka
MouseIns db        0                        ; 1=pznak instalace myi
MouseAkt db        0                        ; 1=pznak zapnut kurzoru myi

; -----------------------------------------------------------------------------
;        barvy
; -----------------------------------------------------------------------------

ColDat   db        1bh                      ; barva data a asu

ColNadp  db        1bh                      ; barva textu nadpisu

ColVol0  db        1bh
ColVol   db        1fh                      ; barva textu voleb v nadpisu
ColVolK  db        30h                      ; barva kurzoru
ColEdi   db        0fh                      ; barva editovan poloky

ColDiskR db        1eh                      ; barva rmu volby formtu
ColDisk1 db        1bh                      ; bn barva
;ColDisk2 db        1fh                      ; vysvcen barva poloek
ColDisk3 db        30h                      ; barva kurzoru
ColDisk4 db        1eh                      ; barva hork klvesy

ColRamN  db        1eh                      ; barva rmu nadpisu

ColPod   db        70h                      ; barva podkladu obrazovky

ColHelp  db        30h                      ; zkladn barva textu npovdy
ColHelp1 db        34h                      ; vysvcen barva textu npovdy

ColRF    db        1bh                      ; barva rmeku formtovn
ColRFR   db        1eh                      ; barva rmeku
ColRF0   db        1fh                      ; vysvcen barva rmeku
ColRFNul db        7                        ; barva - przdn pole v rmeku

ColForm  db        70h                      ; znaka formtovn
ColVerif db        70h                      ; znaka verifikace
ColWrite db        70h                      ; znaka zpisu
ColRead  db        70h                      ; znaka ten
ColOK    db        0ah                      ; barva OK
ColErr   db        4eh                      ; barva chyby

; -----------------------------------------------------------------------------
;        diskov parametry
; -----------------------------------------------------------------------------

BufferW  dw        0                        ; segment bufferu pro zpis
BufferR  dw        0                        ; segment bufferu pro ten
BufferD  dw        0                        ; segment bufferu pro schovu stopy
BufferF  dw        0                        ; segment bufferu s tabulkou FAT

NumDisk  db        0                        ; poet disk v systmu
TypDiskT db        4 dup(1)                 ; tabulka typ disk
PozDiskT db        4 dup(0)                 ; tabulka pozic k zobrazen disk

TypDisk  db        1                        ; typ aktivnho disku
                                            ;    1 = 360 K
                                            ;    2 = 1.2 M
                                            ;    3 = 720 K
                                            ;    4 = 1.44 M
                                            ;    5 = 2.88 M

AktVolby db        0                        ; pznak aktivnch voleb

AktForm  db        -1                       ; aktivn formt (-1=neplat)
NumForm  db        0                        ; poet monch formt disku
AktStop  db        0                        ; aktivn stopa
AktStran db        0                        ; aktivn strana

Krokov   db        0                        ; pznak dvojitho krokovn
TypStop  db        39                       ; jmenovit poet stop - 1
NumStop  db        40                       ; celkov poet stop disku
BlokByte dw        400h                     ; poet bajt na alokan blok
RootSekt db        7                        ; poet sektor na ROOT
         db        0                        ; doplnk na slovo

CelkBlok dw        (2*40*9-1-7-2*2)/2       ; celkov poet datovch blok
CelkKap  dd        362000                   ; celkov kapacita disku
FirstDat dw        0                        ; prvn datov sektor absolutn

CitVol   dd        0                        ; ta voln kapacity disku
CitBad   dd        0                        ; ta vadnch dat disku

ErrBoot  db        1                        ; pznak BOOT (0=OK, FF=vadn, 1=?)
ErrFAT1  db        1                        ; pznak FAT1 (0=OK, FF=vadn, 1=?)
ErrFAT2  db        1                        ; pznak FAT2 (0=OK, FF=vadn, 1=?)
ErrRoot  db        1                        ; pznak ROOT (0=OK, FF=vadn, 1=?)
ErrDat   db        0                        ; pznak chyby 1. sektoru bloku

SlidX    db        0                        ; odsazen sektor stran (SLIDING X)
SlidY    db        0                        ; odsazen sektor vlc (SLIDING Y)
Inter    db        1                        ; prokldn sektor (1 nebo 2)
Smer     db        0                        ; smr formtovn (0=nahoru)

PozMap   dw        11*HI+2                  ; pozice k zobrazen mapy disku
SirMap   dw        13*HI+53                 ; ka a vka okna mapy disku
CitMap   db        40                       ; ta stop mapy

; -----------------------------------------------------------------------------
;        definice formt disk
; -----------------------------------------------------------------------------
; Zkladn parametry:
;     0: (1) pznaky
;               bit 0: 1=80 stop
;               bit 1: 1=v oboustrannm formtu 2 sektory na blok
;               bit 2: 1=dvojit krokovn
;               bit 3: 1=nestandardn formt pro tuto mechaniku
;               bit 4: 1=faktor prokldn = 2
;               bit 5: 1=provd se odstup sektor SLIDING (1 a 2 nebo 2 a 3)
;     1: (1) poet sektor na stopu (8, 9, 15 nebo 18)
;     2: (1) poet sektor na ROOT
;     3: (1) popisova mdia v jednostrannm formtu
;     4: (5) nzev formtu pro zobrazen v menu
; Poet sektor na ROOT v jednostrannm formtu: vydlen 2 + penos CF
; Poet sektor na ROOT v spornm formtu: vydlen 2 (bez penosu)
; Popisova mdia v oboustranm formtu: popisova OR 1
; -----------------------------------------------------------------------------

TabForm  dw        Form1                    ; adresy definic formt
         dw        Form2
         dw        Form3
         dw        Form4
         dw        Form5

Form1    label     byte                     ; definice formt mechaniky typu 1
         db        3
         db        b1,    9, 7,0fch,' 360K'
         db        b1,    8, 7,0feh,' 320K'
         db  b5+b3+b1,   10, 7,0fch,' 400K'

Form2    label     byte                     ; definice formt mechaniky typu 2
         db        6
         db        b0,   15,14,0f9h,' 1.2M'
         db        b1+b2, 9, 7,0fch,' 360K'
         db        b1+b2, 8, 7,0feh,' 320K'
         db  b5+b4+b3+b0,18,14,0f9h,'1.44M'
         db  b5+b3+b0+b1,10, 7,0f9h,' 800K'
         db     b3+b0+b1, 9, 7,0f9h,' 720K'

Form3    label     byte                     ; definice formt mechaniky typu 3
         db        6
         db        b0+b1, 9, 7,0f9h,' 720K'
         db  b5+b3+b0+b1,12, 7,0f9h,' 980K'
         db  b5+b3+b0+b1,10, 7,0f9h,' 800K'
         db  b5+b3+b1,   10, 7,0fch,' 400K'
         db     b3+b1+b2, 9, 7,0fch,' 360K'
         db     b3+b1+b2, 8, 7,0feh,' 320K'

Form4    label     byte                     ; definice formt mechaniky typu 4
         db        7
         db        b0,   18,14,0f9h,'1.44M'
         db        b0+b1, 9, 7,0f9h,' 720K'
         db  b5+b4+b3+b0,21,14,0f9h,'1.68M'
         db     b3+b0,   15,14,0f9h,' 1.2M'
         db  b5+b3+b0+b1,12, 7,0f9h,' 980K'
         db  b5+b3+b0+b1,10, 7,0f9h,' 800K'
         db     b3+b1+b2, 9, 7,0fch,' 360K'

Form5    label     byte                     ; definice formt mechaniky typu 5
         db        7
         db        b0,   36,28,0f9h,'2.88M'
         db        b0,   18,14,0f9h,'1.44M'
         db        b0+b1, 9, 7,0f9h,' 720K'
         db  b5+b4+b3+b0,21,14,0f9h,'1.68M'
         db     b3+b0,   15,14,0f9h,' 1.2M'
         db  b5+b3+b0+b1,12, 7,0f9h,' 980K'
         db     b3+b1+b2, 9, 7,0fch,' 360K'

; -----------------------------------------------------------------------------
;        konfigurace programu
; -----------------------------------------------------------------------------

Konfig   label     byte

KonfIdnt db        'FORM'                   ; identifikan text souboru
KonfVer  db        20h                      ; verze programu FORM

AktDisk  db        0                        ; aktivn disk
AktVol   db        0                        ; aktivn poloka voleb
ParSys   db        0                        ; pznak - je operan systm
ParLab   db        0                        ; pznak - zadv se nvt
ParDat   db        0                        ; pznak - zachovn dat
ParStra  db        0                        ; pznak - jedna strana
ParRoot  db        0                        ; poet sektor v ROOT (0=stand.)
ParObs   db        1                        ; pznak - zobrazen obsahu
ParStrt  db        0                        ; pznak - zrychlen start
ParBack  db        0                        ; pznak - zptn smr
ParInd   db        1                        ; pznak - zvukov indikace
ParVerif db        1                        ; pznak - provdn verifikace
ParStop  db        0                        ; poet doplujcch stop (0 a 6)
ParTest  db        0                        ; poet testovacch zpis
ParChar  db        0f6h                     ; formtovac znak
ParOptim db        1                        ; pznak - optimalizace chyb
ParCest  db        1                        ; etina na displeji
                                            ;   0=bez
                                            ;   1=Vlastn
                                            ;   2=Kamenickch
                                            ;   3=Latin 2
AktFormT db        4 dup(0)                 ; aktivn formty disk A a D

Konfig0  label     byte

TabBad   db        MAXSEKT dup(?)           ; tabulka vadnch sektor stopy

         db        300h dup(?)              ; zsobnk
Konec    label     byte                     ; konec programu

CODE     ENDS

         END       Start
